﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Threading;
using System.Windows.Forms;

using INT69DB_2A_ImageDll;
using INT69DB_2A.Controls;
using INT69DB_2A.Part11_UserManager;
using INT69DB_2A.DialogForms;

namespace INT69DB_2A.Forms
{
    public partial class FormUserEditor : Form
    {
        #region Field
        private FormMain m_ParentForm;

        private UserItem SelectedUserItem;
        private ControlUserSetting ChildControlUserSet;
        #endregion

        #region Constructor
        public FormUserEditor(FormMain parent)
        {
            InitializeComponent();

            this.ParentForm = parent;

            this.InitializeDesign();
            this.DefaultSetting();
        }
        #endregion

        #region Property
        public FormMain ParentForm
        {
            get { return this.m_ParentForm; }
            set { this.m_ParentForm = value; }
        }
        #endregion

        #region Method
        private void InitializeDesign()
        {
            ImageDll images = new ImageDll();

            if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.Korean)
            {

            }
            else if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.English)
            {
                this.labelTitle.Text = "User";
            }
            else if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.Chinese)
            {
                this.labelTitle.Text = "用户设置";
            }
            else if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.Czech)
            {
                this.labelTitle.Text = "uživatelské nastavení";
            }
            else if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.German)
            {
                this.labelTitle.Text = "Benutzereinstellungen";
            }
            else
            {

            }
        }
        private void DefaultSetting()
        {
            this.UpdateInitializeUserDisplay(this.ParentForm.SystemConfig);

            this.ChildControlUserSet = new ControlUserSetting(this);
            this.Controls.Add(this.ChildControlUserSet);
            this.ChildControlUserSet.Location = new Point(0, 73);
            this.ChildControlUserSet.Visible = false;
        }

        private void SetEnableID(bool value)
        {
            if (value == true)
                this.labelID.BackColor = Color.White;
            else
                this.labelID.BackColor = Color.Silver;
        }
        private void SetEnablePassword(bool value)
        {
            if (value == true)
                this.labelPassword.BackColor = Color.White;
            else
                this.labelPassword.BackColor = Color.Silver;
        }

        private void SaveUserDll()
        {
            string code = "", message1 = "", message2 = "";
            bool isNewReg = false;

            if (this.listBoxUserList.SelectItemIndex == -1)
                isNewReg = true;
            else
                isNewReg = false;

            if (isNewReg == true)
            {
                switch (this.ParentForm.SystemConfig.Language)
                {
                    case DataStore.LanguageID.Korean:
                        code = "유저 설정";
                        message1 = "신규 사용자 추가 하시겠습니까?";
                        message2 = "";
                        break;
                    case DataStore.LanguageID.English:
                        code = "User Editor";
                        message1 = "Would you like to register as a user?";
                        message2 = "";
                        break;
                    case DataStore.LanguageID.Chinese:
                        code = "User Editor";
                        message1 = "Would you like to register as a user?";
                        message2 = "";
                        break;
                    case DataStore.LanguageID.Czech:
                        code = "User Editor";
                        message1 = "Would you like to register as a user?";
                        message2 = "";
                        break;
                    case DataStore.LanguageID.German:
                        code = "User Editor";
                        message1 = "Would you like to register as a user?";
                        message2 = "";
                        break;
                    default:
                        break;
                }
            }
            else
            {
                switch (this.ParentForm.SystemConfig.Language)
                {
                    case DataStore.LanguageID.Korean:
                        code = "유저 설정";
                        message1 = "선택된 사용자의 정보를 수정 하시겠습니까?";
                        message2 = "";
                        break;
                    case DataStore.LanguageID.English:
                        code = "User Editor";
                        message1 = "Are you sure you want to edit the";
                        message2 = "selected user's information?";
                        break;
                    case DataStore.LanguageID.Chinese:
                        code = "User Editor";
                        message1 = "Are you sure you want to edit the";
                        message2 = "selected user's information?";
                        break;
                    case DataStore.LanguageID.Czech:
                        code = "User Editor";
                        message1 = "Are you sure you want to edit the";
                        message2 = "selected user's information?";
                        break;
                    case DataStore.LanguageID.German:
                        code = "User Editor";
                        message1 = "Are you sure you want to edit the";
                        message2 = "selected user's information?";
                        break;
                    default:
                        break;
                }
            }

            DialogFormYesNo dlg = new DialogFormYesNo(DataStore.MessageBoxIcon.Question, code, message1, message2);
            if (dlg.ShowDialog() == DialogResult.Yes)
            {
                UserItem item = new UserItem();
                DateTime time = DateTime.Now;
                UserManager.MenuID_t menuId = new UserManager.MenuID_t();

                #region ID, Password 검사
                // Chck ID
                if (isNewReg == true)
                {
                    if (this.labelID.Text.Length < 6)
                    {
                        // ID : 6~20자 입력하세요
                        DialogFormMessage msg = new DialogFormMessage(null, 3, this.ParentForm.SystemConfig.Language);
                        msg.ShowDialog();

                        return;
                    }
                }

                // Check Password
                if (this.labelPassword.Text.Length < 5)
                {
                    // PASSWORD : 6~20자 입력하세요
                    DialogFormMessage msg = new DialogFormMessage(null, 9, this.ParentForm.SystemConfig.Language);
                    msg.ShowDialog();
                    return;
                }

                if (this.labelAccessRight.Text == "")
                {
                    DialogFormMessage msg = new DialogFormMessage(null, 16, this.ParentForm.SystemConfig.Language);
                    msg.ShowDialog();

                    return;
                }

                if (this.labelExpireAccount.Text == "000")
                {
                    DialogFormMessage msg = new DialogFormMessage(null, 16, this.ParentForm.SystemConfig.Language);
                    msg.ShowDialog();

                    return;
                }

                if (this.labelExpirePassword.Text == "00")
                {
                    DialogFormMessage msg = new DialogFormMessage(null, 16, this.ParentForm.SystemConfig.Language);
                    msg.ShowDialog();

                    return;
                }
                #endregion

                item.ID = this.labelID.Text;
                item.SetPassword(this.labelPassword.Text);
                item.ExpireAccount = int.Parse(this.labelExpireAccount.Text);
                item.ExpirePassword = int.Parse(this.labelExpirePassword.Text);

                //item.IsAdmin = this.cbAdministrator.Checked;

                if (this.buttonLevel1.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
                    item.ActiveLevel = 1;
                if (this.buttonLevel2.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
                    item.ActiveLevel = 2;
                if (this.buttonLevel3.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
                    item.ActiveLevel = 3;

                menuId.fMenu = new bool[UserManager.USER_MENU_ID_MAX];
                for (int i = 0; i < UserManager.USER_MENU_ID_MAX; i++)
                    menuId.fMenu[i] = false;

                if (isNewReg == true)
                {
                    #region 신규 등록
                    UserManager.UserManager_UserNew(item.ID, item.Password, item.IsAdmin == false ? 0 : 1, item.ExpirePassword, item.ExpireAccount, item.ActiveLevel, menuId);
                    #endregion
                }
                else
                {
                    #region 유저 수정
                    UserManager.UserManager_UserModify(item.ID, item.Password, item.IsAdmin == false ? 0 : 1, item.ExpirePassword, item.ExpireAccount, item.ActiveLevel, menuId);
                    #endregion
                }

                #region 자동 로그아웃 타임
                //this.ParentForm.ParentForm.SystemConfig.AUTOMATIC_LOGOUT = int.Parse(this.labelAutomaticLogoutTime.Text);

                //if (this.ParentForm.ParentForm.SystemConfig.AUTOMATIC_LOGOUT == 1)
                //    this.ParentForm.ParentForm.FlagAutomaticLogoutWarningTime = 30;
                //else
                //    this.ParentForm.ParentForm.FlagAutomaticLogoutWarningTime = 60;

                //UserManager.UserManager_AutoLogoutSetTimeout(this.ParentForm.ParentForm.SystemConfig.AUTOMATIC_LOGOUT, this.ParentForm.ParentForm.FlagAutomaticLogoutWarningTime);
                #endregion
            }
        }
        private void ChangeUserControlEnable(bool enable)
        {
            this.listBoxUserList.Enabled = enable;
            this.smartGroupBox1.Enabled = enable;
            this.buttonDefaultGroup.Enabled = enable;
            this.buttonBack.Enabled = enable;
        }
        private void UserNew()
        {
            this.listBoxUserList.SelectedIndexChanged -= new EventHandler(this.listBoxUserList_SelectedIndexChanged);
            this.listBoxUserList.SelectItemIndex = -1;
            this.listBoxUserList.SelectedIndexChanged += new EventHandler(this.listBoxUserList_SelectedIndexChanged);

            this.UpdateInitializeUserDisplay(this.ParentForm.SystemConfig);

            this.buttonDelete.Enabled = false;
            this.labelID.Enabled = true;
            this.labelID.BackColor = Color.WhiteSmoke;
        }
        private Color ReturnColor(bool bValue)
        {
            if (bValue == true)
                return Color.Black;
            else
                return Color.Silver;
        }
        private void CheckBoxCheckedAsLevel(DataStore.UserStatus level)
        {
            switch (level)
            {
                case DataStore.UserStatus.Level1:
                    this.buttonLevel2.ButtonUp();
                    this.buttonLevel3.ButtonUp();
                    this.buttonLevel1.ButtonDown();
                    this.buttonLevel1.Enabled = true;
                    this.buttonLevel2.Enabled = true;
                    this.buttonLevel3.Enabled = true;

                    this.labelAccessRight.Text = this.ParentForm.SystemConfig.User_Level1_Name;

                    this.labelProductNo.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayProductNo);
                    this.labelClear.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayClear);
                    this.labelSubMenu.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMainDisplaySubMenu);
                    this.labelWeightSetting.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayWeightSetting);

                    this.labelInformation.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuInformation);
                    this.labelConfiguration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuConfiguration);
                    this.labelCommunication.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuCommunication);
                    this.labelCalibration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuCalibration);
                    this.labelSystem.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuSystem);
                    this.labelMotor.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuMotor);
                    this.labelIOTest.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuIOTest);
                    this.labelEquipment.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuEquipment);
                    this.labelUpdate.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuUpdate);
                    this.labelInitialization.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuInitialization);
                    this.labelTime.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuTime);
                    this.labelUser.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuUser);
                    this.labelDataBackup.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuDataBackup);
                    this.labelStatistics.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuStatistics);
                    this.labelViewer.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level1.IsMenuViewer);
                    break;
                case DataStore.UserStatus.Level2:
                    this.buttonLevel1.ButtonUp();
                    this.buttonLevel3.ButtonUp();
                    this.buttonLevel2.ButtonDown();
                    this.buttonLevel1.Enabled = true;
                    this.buttonLevel2.Enabled = true;
                    this.buttonLevel3.Enabled = true;

                    this.labelAccessRight.Text = this.ParentForm.SystemConfig.User_Level2_Name;

                    this.labelProductNo.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayProductNo);
                    this.labelClear.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayClear);
                    this.labelSubMenu.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMainDisplaySubMenu);
                    this.labelWeightSetting.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayWeightSetting);

                    this.labelInformation.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuInformation);
                    this.labelConfiguration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuConfiguration);
                    this.labelCommunication.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuCommunication);
                    this.labelCalibration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuCalibration);
                    this.labelSystem.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuSystem);
                    this.labelMotor.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuMotor);
                    this.labelIOTest.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuIOTest);
                    this.labelEquipment.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuEquipment);
                    this.labelUpdate.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuUpdate);
                    this.labelInitialization.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuInitialization);
                    this.labelTime.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuTime);
                    this.labelUser.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuUser);
                    this.labelDataBackup.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuDataBackup);
                    this.labelStatistics.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuStatistics);
                    this.labelViewer.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level2.IsMenuViewer);
                    break;
                case DataStore.UserStatus.Level3:
                    this.buttonLevel1.ButtonUp();
                    this.buttonLevel2.ButtonUp();
                    this.buttonLevel3.ButtonDown();
                    this.buttonLevel1.Enabled = true;
                    this.buttonLevel2.Enabled = true;
                    this.buttonLevel3.Enabled = true;

                    this.labelAccessRight.Text = this.ParentForm.SystemConfig.User_Level3_Name;

                    this.labelProductNo.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayProductNo);
                    this.labelClear.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayClear);
                    this.labelSubMenu.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMainDisplaySubMenu);
                    this.labelWeightSetting.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayWeightSetting);

                    this.labelInformation.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuInformation);
                    this.labelConfiguration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuConfiguration);
                    this.labelCommunication.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuCommunication);
                    this.labelCalibration.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuCalibration);
                    this.labelSystem.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuSystem);
                    this.labelMotor.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuMotor);
                    this.labelIOTest.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuIOTest);
                    this.labelEquipment.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuEquipment);
                    this.labelUpdate.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuUpdate);
                    this.labelInitialization.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuInitialization);
                    this.labelTime.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuTime);
                    this.labelUser.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuUser);
                    this.labelDataBackup.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuDataBackup);
                    this.labelStatistics.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuStatistics);
                    this.labelViewer.ForeColor = this.ReturnColor(this.ParentForm.CurrentUserGroup.Level3.IsMenuViewer);
                    break;
                case DataStore.UserStatus.Developer:
                case DataStore.UserStatus.Admin:
                    this.buttonLevel1.ButtonUp();
                    this.buttonLevel2.ButtonUp();
                    this.buttonLevel3.ButtonUp();
                    this.buttonLevel1.Enabled = false;
                    this.buttonLevel2.Enabled = false;
                    this.buttonLevel3.Enabled = false;

                    this.labelAccessRight.Text = "Admin";

                    this.labelProductNo.ForeColor = Color.Black;
                    this.labelClear.ForeColor = Color.Black;
                    this.labelSubMenu.ForeColor = Color.Black;
                    this.labelWeightSetting.ForeColor = Color.Black;

                    this.labelInformation.ForeColor = Color.Black;
                    this.labelConfiguration.ForeColor = Color.Black;
                    this.labelCommunication.ForeColor = Color.Black;
                    this.labelCalibration.ForeColor = Color.Black;
                    this.labelSystem.ForeColor = Color.Black;
                    this.labelMotor.ForeColor = Color.Black;
                    this.labelIOTest.ForeColor = Color.Black;
                    this.labelEquipment.ForeColor = Color.Black;
                    this.labelUpdate.ForeColor = Color.Black;
                    this.labelInitialization.ForeColor = Color.Black;
                    this.labelTime.ForeColor = Color.Black;
                    this.labelUser.ForeColor = Color.Black;
                    this.labelDataBackup.ForeColor = Color.Black;
                    this.labelStatistics.ForeColor = Color.Black;
                    this.labelViewer.ForeColor = Color.Black;
                    break;
                default:
                    this.buttonLevel1.ButtonUp();
                    this.buttonLevel2.ButtonUp();
                    this.buttonLevel3.ButtonUp();
                    this.buttonLevel1.Enabled = true;
                    this.buttonLevel2.Enabled = true;
                    this.buttonLevel3.Enabled = true;

                    this.labelAccessRight.Text = "";
                    break;
            }
        }

        private void UpdateInitializeUserDisplay(SystemConfigurationItem system)
        {
            this.SelectedUserItem = new UserItem();

            this.labelID.Text = "";
            this.labelPassword.Text = "";
            this.labelExpireAccount.Text = "180";
            this.labelExpirePassword.Text = "90";
            this.labelExpireAccountDate.Text = "yyyy.mm.DD";
            this.labelExpirePasswordDate.Text = "yyyy.mm.DD";
            this.labelAccessRight.Text = system.User_Level1_Name;

            this.buttonLevel1.ButtonDown();
            this.buttonLevel2.ButtonUp();
            this.buttonLevel3.ButtonUp();
            this.buttonLevel1.Text = system.User_Level1_Name;
            this.buttonLevel2.Text = system.User_Level2_Name;
            this.buttonLevel3.Text = system.User_Level3_Name;

            this.labelStatusExpireAccount.Visible = false;
            this.labelStatusExpirePassword.Visible = false;
            this.buttonDelete.Enabled = false;

            this.UpdateDefaultSetAccessrightDisplay(this.ParentForm.CurrentUserGroup.Level1);

            this.labelAutomaticLogout.Text = system.AutomaticLogout.ToString();
        }
        private void UpdateCurrentUserItem(UserManager.UserMgr_user_list_t item)
        {
            // CurrentUserItem SET
            this.SelectedUserItem.ID = item.user_id;
            this.SelectedUserItem.Password = item.user_pw;

            this.SelectedUserItem.ExpireAccount = item.expire_period_account;
            this.SelectedUserItem.ExpirePassword = item.expire_period_pw;

            DateTime time = DateTime.ParseExact(item.register_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateRegister = time;
            time = DateTime.ParseExact(item.login_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateLogin = time;
            time = DateTime.ParseExact(item.expire_account_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateExpireRegister = time;
            time = DateTime.ParseExact(item.expire_register_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateExpireLogin = time;

            this.SelectedUserItem.IsLockAccount = item.flock_status_account == 0 ? false : true;
            this.SelectedUserItem.IsLockPassword = item.flock_status_password == 0 ? false : true;

            this.SelectedUserItem.IsAdmin = item.fadmin == 0 ? false : true;
            this.SelectedUserItem.ActiveLevel = item.active_level;

            if (this.SelectedUserItem.ActiveLevel == 1)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level1;
            else if (this.SelectedUserItem.ActiveLevel == 2)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level2;
            else if (this.SelectedUserItem.ActiveLevel == 3)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level3;
            else if (this.SelectedUserItem.ActiveLevel == 9)
                this.SelectedUserItem.Status = DataStore.UserStatus.Admin;
            else if (this.SelectedUserItem.ActiveLevel == 10)
                this.SelectedUserItem.Status = DataStore.UserStatus.Developer;
            else
                this.SelectedUserItem.Status = DataStore.UserStatus.None;
        }
        private void UpdateCurrentUserItem(UserManager.UserMgr_user_info_t item)
        {
            // CurrentUserItem SET
            this.SelectedUserItem.ID = item.user_id;
            this.SelectedUserItem.Password = item.user_pw;

            this.SelectedUserItem.ExpireAccount = item.expire_period_account;
            this.SelectedUserItem.ExpirePassword = item.expire_period_pw;

            DateTime time = DateTime.ParseExact(item.register_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateRegister = time;
            time = DateTime.ParseExact(item.login_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateLogin = time;
            time = DateTime.ParseExact(item.expire_account_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateExpireRegister = time;
            time = DateTime.ParseExact(item.expire_register_date.GetDateTime(), "yyyyMMddHHmmss", null);
            this.SelectedUserItem.DateExpireLogin = time;

            this.SelectedUserItem.IsLockAccount = item.flock_status_account == 0 ? false : true;
            this.SelectedUserItem.IsLockPassword = item.flock_status_password == 0 ? false : true;

            this.SelectedUserItem.IsAdmin = item.fadmin == 0 ? false : true;
            this.SelectedUserItem.ActiveLevel = item.active_level;

            if (item.active_level == 1)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level1;
            else if (item.active_level == 2)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level2;
            else if (item.active_level == 3)
                this.SelectedUserItem.Status = DataStore.UserStatus.Level3;
            else if (item.active_level == 9)
                this.SelectedUserItem.Status = DataStore.UserStatus.Admin;
            else if (item.active_level == 10)
                this.SelectedUserItem.Status = DataStore.UserStatus.Developer;
        }
        private void UpdateSelectUserDisplay(UserItem item)
        {
            // 화면 Enable 처리 추가할것
            this.ChangeUserControlEnable(true);
            this.labelID.Enabled = false;
            this.labelID.BackColor = Color.LightGray;

            this.labelID.Text = item.ID;
            this.labelPassword.Text = item.Password;
            this.labelExpireAccount.Text = item.ExpireAccount.ToString();
            this.labelExpirePassword.Text = item.ExpirePassword.ToString();
            this.labelExpireAccountDate.Text = string.Format("{0:yyyy/MM/dd} ~ {1:yyyy/MM/dd}", item.DateRegister, item.DateExpireRegister);
            this.labelExpirePasswordDate.Text = string.Format("{0:yyyy/MM/dd} ~ {1:yyyy/MM/dd}", item.DateLogin, item.DateExpireLogin);
            this.labelStatusExpireAccount.Visible = item.IsLockAccount;
            this.labelStatusExpirePassword.Visible = item.IsLockPassword;

            this.CheckBoxCheckedAsLevel(item.Status);

            //this.cbAdministrator.Visible = true;
            //this.cbAdministrator.Checked = item.IsAdmin;
        }
        private void UpdateUserListBoxDisplay(List<string> items)
        {
            this.listBoxUserList.ClearAll();
            for (int i = 1; i < items.Count; i++)
                this.listBoxUserList.AddItem(items[i]);
        }
        private void UpdateDefaultSetAccessrightDisplay(UserGroupItem item)
        {
            this.labelProductNo.ForeColor = this.ReturnColor(item.IsMainDisplayProductNo);
            this.labelWeightSetting.ForeColor = this.ReturnColor(item.IsMainDisplayWeightSetting);
            this.labelClear.ForeColor = this.ReturnColor(item.IsMainDisplayClear);
            this.labelSubMenu.ForeColor = this.ReturnColor(item.IsMainDisplaySubMenu);

            this.labelInformation.ForeColor = this.ReturnColor(item.IsMenuInformation);
            this.labelConfiguration.ForeColor = this.ReturnColor(item.IsMenuConfiguration);
            this.labelCommunication.ForeColor = this.ReturnColor(item.IsMenuCommunication);
            this.labelCalibration.ForeColor = this.ReturnColor(item.IsMenuCalibration);
            this.labelSystem.ForeColor = this.ReturnColor(item.IsMenuSystem);
            this.labelMotor.ForeColor = this.ReturnColor(item.IsMenuMotor);
            this.labelIOTest.ForeColor = this.ReturnColor(item.IsMenuIOTest);
            this.labelEquipment.ForeColor = this.ReturnColor(item.IsMenuEquipment);
            this.labelUpdate.ForeColor = this.ReturnColor(item.IsMenuUpdate);
            this.labelInitialization.ForeColor = this.ReturnColor(item.IsMenuInitialization);
            this.labelTime.ForeColor = this.ReturnColor(item.IsMenuTime);
            this.labelUser.ForeColor = this.ReturnColor(item.IsMenuUser);
            this.labelDataBackup.ForeColor = this.ReturnColor(item.IsMenuDataBackup);
            this.labelStatistics.ForeColor = this.ReturnColor(item.IsMenuStatistics);
            this.labelViewer.ForeColor = this.ReturnColor(item.IsMenuViewer);
        }

        public void CallBackGetUserData(UserManager.UserMgr_user_list_t user)
        {
            this.UpdateCurrentUserItem(user);

            this.UI_Invoke(delegate
            {
                this.UpdateSelectUserDisplay(this.SelectedUserItem);
            });
        }
        public void CallBackUserListNewData(UserManager.UserMgr_user_info_t user)
        {
            string code = "", message1 = "", message2 = "", detail = "";

            switch (this.ParentForm.SystemConfig.Language)
            {
                case DataStore.LanguageID.Korean:
                    code = "유저설정";
                    message1 = "사용자 추가 완료!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.English:
                    code = "user settings";
                    message1 = "User addition complete!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Chinese:
                    code = "用户设置";
                    message1 = "用户添加完成!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Czech:
                    code = "uživatelské nastavení";
                    message1 = "Přidání uživatele dokončeno!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.German:
                    code = "Benutzereinstellungen";
                    message1 = "Benutzer hinzufügen abgeschlossen!";
                    message2 = "";
                    break;
                default:
                    break;
            }

            if (user.status == (int)UserManager.E_user_mgr_status.USER_MGR_STATUS_OK)
            {
                this.UI_Invoke(delegate
                {
                    // Part 11
                    detail = string.Format("Add : {0}", user.user_id);
                    this.ParentForm.SetTrackingHistoryData(DataStore.TrackingOperation.UserEditor, detail);

                    this.UpdateCurrentUserItem(user);
                    this.UpdateSelectUserDisplay(this.SelectedUserItem);

                    this.ParentForm.ListDllUserName.Add(user.user_id);
                    this.UpdateUserListBoxDisplay(this.ParentForm.ListDllUserName);
                    this.listBoxUserList.SelectItemIndex = this.listBoxUserList.ItemCount - 1;

                    this.buttonDelete.Enabled = true;
                    this.labelID.Enabled = false;
                    this.labelID.BackColor = Color.LightGray;

                    DialogFormMessage dlg = new DialogFormMessage(DataStore.MessageBoxIcon.Asterisk, code, message1, message2, 0);
                    dlg.ShowDialog();
                });
            }
            else
            {
                DialogFormMessage msg = new DialogFormMessage(null, user.status, this.ParentForm.SystemConfig.Language);
                msg.ShowDialog();
            }
        }
        public void CallBackUserModifyUserData(UserManager.UserMgr_user_modify_t user)
        {
            string code = "", message1 = "", message2 = "", detail = "";

            switch (this.ParentForm.SystemConfig.Language)
            {
                case DataStore.LanguageID.Korean:
                    code = "유저설정";
                    message1 = "사용자 정보 수정 완료!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.English:
                    code = "user settings";
                    message1 = "User information modified!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Chinese:
                    code = "用户设置";
                    message1 = "用户信息修改!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Czech:
                    code = "uživatelské nastavení";
                    message1 = "Informace o uživateli upraveny!";
                    message2 = "";
                    break;
                case DataStore.LanguageID.German:
                    code = "Benutzereinstellungen";
                    message1 = "Benutzerinformationen geändert!";
                    message2 = "";
                    break;
                default:
                    break;
            }

            if (user.status == (int)UserManager.E_user_mgr_status.USER_MGR_STATUS_OK)
            {
                this.UI_Invoke(delegate
                {
                    // Part 11
                    detail = string.Format("Modify : {0}", user.user_id);
                    this.ParentForm.SetTrackingHistoryData(DataStore.TrackingOperation.UserEditor, detail);

                    // 메시지 박스 교체
                    UserManager.UserManager_GetUserListID(this.listBoxUserList.Items[this.listBoxUserList.SelectItemIndex]);

                    DialogFormMessage dlg = new DialogFormMessage(DataStore.MessageBoxIcon.Asterisk, code, message1, message2, 0);
                    dlg.ShowDialog();
                });
            }
            else
            {
                DialogFormMessage msg = new DialogFormMessage(null, user.status, this.ParentForm.SystemConfig.Language);
                msg.ShowDialog();
            }
        }
        public void CallBackUserListLockDataEvent(UserManager.UserMgr_user_lock_t user)
        {
            if (user.user_id == this.SelectedUserItem.ID)
            {
                this.SelectedUserItem.IsLockAccount = user.flock_status_account == 0 ? false : true;
                this.SelectedUserItem.IsLockPassword = user.flock_status_password == 0 ? false : true;

                UserManager.UserManager_GetUserListID(this.listBoxUserList.Items[this.listBoxUserList.SelectItemIndex]);
            }
        }
        public void CallBackUserListDeleteDataEvent(UserManager.UserMgr_user_del_t user)
        {
            string code = "", message1 = "", message2 = "", detail = "";

            switch (this.ParentForm.SystemConfig.Language)
            {
                case DataStore.LanguageID.Korean:
                    code = "유저설정";
                    message1 = string.Format("{0} 사용자 삭제 완료!", user.user_id);
                    message2 = "";
                    break;
                case DataStore.LanguageID.English:
                    code = "user settings";
                    message1 = string.Format("{0} User deletion complete!", user.user_id);
                    message2 = "";
                    break;
                case DataStore.LanguageID.Chinese:
                    code = "用户设置";
                    message1 = string.Format("{0} 用户删除完成!", user.user_id);
                    message2 = "";
                    break;
                case DataStore.LanguageID.Czech:
                    code = "uživatelské nastavení";
                    message1 = string.Format("{0} Smazání uživatele dokončeno!", user.user_id);
                    message2 = "";
                    break;
                case DataStore.LanguageID.German:
                    code = "Benutzereinstellungen";
                    message1 = string.Format("{0} Benutzerlöschung abgeschlossen!", user.user_id);
                    message2 = "";
                    break;
                default:
                    break;
            }


            if (user.status == 0)
            {
                for (int i = 0; i < this.ParentForm.ListDllUserName.Count; i++)
                {
                    if (this.ParentForm.ListDllUserName[i] == user.user_id)
                    {
                        this.ParentForm.ListDllUserName.RemoveAt(i);
                        break;
                    }
                }

                this.UI_Invoke(delegate
                {
                    this.UpdateUserListBoxDisplay(this.ParentForm.ListDllUserName);

                    this.UserNew();

                    DialogFormMessage dlg = new DialogFormMessage(DataStore.MessageBoxIcon.Asterisk, code, message1, message2, 0);
                    dlg.ShowDialog();
                });

                // Part 11
                if (this.ParentForm.SystemConfig.IsPart11 == true)
                {
                    detail = string.Format("Delete : {0}", user.user_id);
                    this.ParentForm.SetTrackingHistoryData(DataStore.TrackingOperation.UserEditor, detail);
                }
            }
            else
            {
                DialogFormMessage msg = new DialogFormMessage(null, user.status, this.ParentForm.SystemConfig.Language);
                msg.ShowDialog();
            }
        }
        public void CallBackUserListModifyInfoDataEvent(UserManager.UserMgr_user_info_t user)
        {
            //if (this.ChildControlUserSet.Visible == true)
            //{
            this.ChildControlUserSet.CallBackUserListModifyInfoDataEvent(user);
            //}
        }

        private bool UI_Invoke(ThreadStart invoker)
        {
            try
            {
                if (this.InvokeRequired)
                {
                    if (this.IsDisposed)
                        return true;

                    this.Invoke(invoker);
                }
                else
                {
                    invoker();
                }

                return true;

            }
            catch (Exception e)
            {
                return false;
            }
        }

        public void DisplayRefresh()
        {
            this.ParentForm.SystemConfig.CurrentForm = DataStore.FormStore.FormUserEditor;

            if (this.ParentForm.SystemConfig.CurrentUser.IsAdmin == true)
            {
                this.buttonDefaultGroup.Visible = true;
                this.ChildControlUserSet.Visible = false;
            }
            else
            {
                this.buttonDefaultGroup.Visible = false;
                this.ChildControlUserSet.Visible = true;
                this.ChildControlUserSet.BringToFront();
                this.ChildControlUserSet.DisplayRefresh();
            }

            this.UpdateInitializeUserDisplay(this.ParentForm.SystemConfig);
            this.UpdateUserListBoxDisplay(this.ParentForm.ListDllUserName);
            this.listBoxUserList.SelectedIndexChanged -= new EventHandler(this.listBoxUserList_SelectedIndexChanged);
            this.listBoxUserList.SelectItemIndex = -1;
            this.listBoxUserList.SelectedIndexChanged += new EventHandler(this.listBoxUserList_SelectedIndexChanged);

            this.buttonNew.Enabled = true;
            this.buttonDelete.Enabled = true;
            this.listBoxUserList.Enabled = true;
            this.SetEnablePassword(true);
            this.SetEnableID(true);
        }
        #endregion

        #region Event Handler
        private void buttonBack_Click(object sender, EventArgs e)
        {
            this.ParentForm.ChildFormMenu.DisplayRefresh();
            ((FormMain)(Owner)).smartForm.Show((int)DataStore.FormStore.FormMenu);
        }
        private void buttonExpireAccount_Click(object sender, EventArgs e)
        {

        }
        private void buttonExpirePassword_Click(object sender, EventArgs e)
        {

        }
        private void buttonNew_Click(object sender, EventArgs e)
        {
            this.UserNew();
        }
        private void buttonSave_Click(object sender, EventArgs e)
        {
            this.SaveUserDll();
        }
        private void buttonDelete_Click(object sender, EventArgs e)
        {
            // 메시지 추가
            // 사용자를 삭제 하시겠습니까?
            DialogFormYesNo dlg = new DialogFormYesNo(this.ParentForm.SystemConfig.Language, 16);
            if (dlg.ShowDialog() == DialogResult.Yes)
            {
                if (this.listBoxUserList.Items.Count <= 1)
                    return;

                if (this.listBoxUserList.SelectItemIndex <= 0)
                    return;

                string id = this.listBoxUserList.Items[this.listBoxUserList.SelectItemIndex];

                UserManager.UserManager_UserDel(id);
            }
        }

        private void buttonDefaultGroup1_Click(object sender, EventArgs e)
        {
            this.UpdateDefaultSetAccessrightDisplay(this.ParentForm.CurrentUserGroup.Level1);
        }
        private void buttonDefaultGroup2_Click(object sender, EventArgs e)
        {
            this.UpdateDefaultSetAccessrightDisplay(this.ParentForm.CurrentUserGroup.Level2);
        }
        private void buttonDefaultGroup3_Click(object sender, EventArgs e)
        {
            this.UpdateDefaultSetAccessrightDisplay(this.ParentForm.CurrentUserGroup.Level3);
        }
        private void buttonDefaultGroup_Click(object sender, EventArgs e)
        {
            this.ParentForm.ChildFormUserGroupEditor.DisplayRefresh();
            ((FormMain)(Owner)).smartForm.Show((int)DataStore.FormStore.FormUserGroupEditor);

            //this.DisplayRefresh();
        }

        private void labelID_Click(object sender, EventArgs e)
        {
            string value = "";
            DialogFormUserEditorKeyboard keyboard = new DialogFormUserEditorKeyboard(this.labelID.Text);

            if (keyboard.ShowDialog() == DialogResult.OK)
            {
                value = keyboard.RetStringValue;

                this.labelID.Text = value;
            }
        }
        private void labelPassword_Click(object sender, EventArgs e)
        {
            string value = "";
            DialogFormUserEditorKeyboard keyboard = new DialogFormUserEditorKeyboard(this.labelPassword.Text);

            if (keyboard.ShowDialog() == DialogResult.OK)
            {
                value = keyboard.RetStringValue;

                this.labelPassword.Text = value;
            }
        }
        private void labelExpireAccount_Click(object sender, EventArgs e)
        {
            DialogFormNumKeyPad myKeyPad = new DialogFormNumKeyPad(this.labelExpireAccount.Text, 3, 0, false, this.ParentForm.SystemConfig.Language);

            if (myKeyPad.ShowDialog() == DialogResult.OK)
            {
                if (myKeyPad.doubleValue < 0 || myKeyPad.doubleValue > 180)
                {
                    // 입력범위를 확인하세요
                    DialogFormMessage myMsg = new DialogFormMessage(1, this.ParentForm.SystemConfig.Language);
                    myMsg.ShowDialog();
                }
                else
                {
                    this.labelExpireAccount.Text = myKeyPad.StringValue;
                }
            }
        }
        private void labelExpirePassword_Click(object sender, EventArgs e)
        {
            DialogFormNumKeyPad myKeyPad = new DialogFormNumKeyPad(this.labelExpirePassword.Text, 3, 0, false, this.ParentForm.SystemConfig.Language);

            if (myKeyPad.ShowDialog() == DialogResult.OK)
            {
                if (myKeyPad.doubleValue < 0 || myKeyPad.doubleValue > 90)
                {
                    // 입력범위를 확인하세요
                    DialogFormMessage myMsg = new DialogFormMessage(1, this.ParentForm.SystemConfig.Language);
                    myMsg.ShowDialog();
                }
                else
                {
                    this.labelExpirePassword.Text = myKeyPad.StringValue;
                }
            }
        }
        private void labelAutomaticLogout_Click(object sender, EventArgs e)
        {
            DialogFormNumKeyPad myKeyPad = new DialogFormNumKeyPad(this.labelAutomaticLogout.Text, 2, 0, false, this.ParentForm.SystemConfig.Language);

            if (myKeyPad.ShowDialog() == DialogResult.OK)
            {
                if (myKeyPad.doubleValue < 0 || myKeyPad.doubleValue > 90)
                {
                    // 입력범위를 확인하세요
                    DialogFormMessage myMsg = new DialogFormMessage(1, this.ParentForm.SystemConfig.Language);
                    myMsg.ShowDialog();
                }
                else
                {
                    this.labelAutomaticLogout.Text = myKeyPad.StringValue;
                    this.ParentForm.SystemConfig.AutomaticLogout = myKeyPad.IntValue;
                    this.ParentForm.SaveSystemConfigurationFile(this.ParentForm.SystemConfig);

                    if (this.ParentForm.SystemConfig.AutomaticLogout == 1)
                        this.ParentForm.FlagAutomaticLogoutWarningTime = 30;
                    else
                        this.ParentForm.FlagAutomaticLogoutWarningTime = 60;

                    UserManager.UserManager_AutoLogoutSetTimeout(this.ParentForm.SystemConfig.AutomaticLogout, this.ParentForm.FlagAutomaticLogoutWarningTime);
                }
            }
        }
        private void labelStatusExpireAccount_Click(object sender, EventArgs e)
        {
            string code = "", message1 = "", message2 = "";

            switch (this.ParentForm.SystemConfig.Language)
            {
                case DataStore.LanguageID.Korean:
                    code = "유저설정";
                    message1 = "사용자 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.English:
                    code = "유저설정";
                    message1 = "사용자 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Chinese:
                    code = "유저설정";
                    message1 = "사용자 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Czech:
                    code = "유저설정";
                    message1 = "사용자 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.German:
                    code = "유저설정";
                    message1 = "사용자 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                default:
                    break;
            }

            DialogFormYesNo dlg = new DialogFormYesNo(DataStore.MessageBoxIcon.Question, code, message1, message2);
            if (dlg.ShowDialog() == DialogResult.Yes)
                UserManager.UserManager_UserLockRelease(this.SelectedUserItem.ID, true, false);
        }
        private void labelStatusExpirePassword_Click(object sender, EventArgs e)
        {
            string code = "", message1 = "", message2 = "";

            switch (this.ParentForm.SystemConfig.Language)
            {
                case DataStore.LanguageID.Korean:
                    code = "유저설정";
                    message1 = "비밀번호 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.English:
                    code = "유저설정";
                    message1 = "비밀번호 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Chinese:
                    code = "유저설정";
                    message1 = "비밀번호 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.Czech:
                    code = "유저설정";
                    message1 = "비밀번호 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                case DataStore.LanguageID.German:
                    code = "유저설정";
                    message1 = "비밀번호 잠금 해제 하시겠습니까?";
                    message2 = "";
                    break;
                default:
                    break;
            }

            DialogFormYesNo dlg = new DialogFormYesNo(DataStore.MessageBoxIcon.Question, code, message1, message2);
            if (dlg.ShowDialog() == DialogResult.Yes)
                UserManager.UserManager_UserLockRelease(this.SelectedUserItem.ID, false, true);
        }

        private void listBoxUserList_SelectedIndexChanged(object sender, EventArgs e)
        {
            int index = this.listBoxUserList.SelectItemIndex;

            if (index != -1)
            {
                if (this.ParentForm.SystemConfig.CurrentUser.ID == this.listBoxUserList.Items[index])
                    this.buttonDelete.Enabled = false;
                else
                    this.buttonDelete.Enabled = true;

                this.ChangeUserControlEnable(true);

                UserManager.UserManager_GetUserListID(this.listBoxUserList.Items[index]);
            }
        }
        #endregion
    }
}