﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using INT69DB_2A.Part11_UserManager;
using SmartX;

namespace INT69DB_2A.Forms
{
    public partial class FormUserGroupEditor : Form
    {
        #region Field
        private FormMain m_ParentForm;

        private Collection<Control> CollectionLevel1Control;
        private Collection<Control> CollectionLevel2Control;
        private Collection<Control> CollectionLevel3Control;
        private Collection<Control> CollectionNotLoginControl;

        private string BeforeTextBox1;
        private string BeforeTextBox2;
        private string BeforeTextBox3;
        #endregion

        #region Constructor
        public FormUserGroupEditor(FormMain parent)
        {
            InitializeComponent();

            this.ParentForm = parent;
            this.InitializeDesign();
            this.DefaultSetting();
        }
        #endregion

        #region Property
        public FormMain ParentForm
        {
            get { return this.m_ParentForm; }
            private set { this.m_ParentForm = value; }
        }
        #endregion

        #region Method
        public void InitializeDesign()
        {
            if (this.ParentForm.SystemConfig.Language == DataStore.LanguageID.English)
            {
                this.labelTitle.Text = "Group Editor";
            }
            else
            {
                this.labelTitle.Text = "그룹 에디터";
            }
        }
        private void DefaultSetting()
        {
            this.BeforeTextBox1 = "";
            this.BeforeTextBox2 = "";
            this.BeforeTextBox3 = "";

            this.CollectionLevel1Control = new Collection<Control>();
            this.CollectionLevel1Control.Add(this.labelTitle1);
            this.CollectionLevel1Control.Add(this.checkBoxL1MainProductNo);
            this.CollectionLevel1Control.Add(this.checkBoxL1MainWeightSet);
            this.CollectionLevel1Control.Add(this.checkBoxL1MainClear);
            this.CollectionLevel1Control.Add(this.checkBoxL1MainSubMenu);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuInformation);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuConfiguration);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuCommunication);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuCalibration);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuSystem);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuMotor);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuIOTest);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuEquipment);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuUpdate);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuInitialization);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuTime);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuUser);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuDataBackup);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuStatistics);
            this.CollectionLevel1Control.Add(this.checkBoxL1MenuViewer);

            this.CollectionLevel2Control = new Collection<Control>();
            this.CollectionLevel2Control.Add(this.labelTitle2);
            this.CollectionLevel2Control.Add(this.checkBoxL2MainProductNo);
            this.CollectionLevel2Control.Add(this.checkBoxL2MainWeightSet);
            this.CollectionLevel2Control.Add(this.checkBoxL2MainClear);
            this.CollectionLevel2Control.Add(this.checkBoxL2MainSubMenu);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuInformation);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuConfiguration);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuCommunication);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuCalibration);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuSystem);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuMotor);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuIOTest);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuEquipment);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuUpdate);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuInitialization);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuTime);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuUser);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuDataBackup);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuStatistics);
            this.CollectionLevel2Control.Add(this.checkBoxL2MenuViewer);

            this.CollectionLevel3Control = new Collection<Control>();
            this.CollectionLevel3Control.Add(this.labelTitle3);
            this.CollectionLevel3Control.Add(this.checkBoxL3MainProductNo);
            this.CollectionLevel3Control.Add(this.checkBoxL3MainWeightSet);
            this.CollectionLevel3Control.Add(this.checkBoxL3MainClear);
            this.CollectionLevel3Control.Add(this.checkBoxL3MainSubMenu);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuInformation);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuConfiguration);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuCommunication);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuCalibration);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuSystem);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuMotor);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuIOTest);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuEquipment);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuUpdate);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuInitialization);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuTime);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuUser);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuDataBackup);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuStatistics);
            this.CollectionLevel3Control.Add(this.checkBoxL3MenuViewer);

            this.CollectionNotLoginControl = new Collection<Control>();
            this.CollectionNotLoginControl.Add(this.labelTitle4);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMainProductNo);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMainWeightSet);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMainClear);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMainSubMenu);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuInformation);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuConfiguration);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuCommunication);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuCalibration);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuSystem);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuMotor);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuIOTest);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuEquipment);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuUpdate);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuInitialization);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuTime);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuUser);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuDataBackup);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuStatistics);
            this.CollectionNotLoginControl.Add(this.checkBoxNotLoginMenuViewer);

            this.UpdateDisplay(this.ParentForm.CurrentUserGroup, this.ParentForm.SystemConfig);
        }

        private void UpdateDisplay(UserGroup group, SystemConfigurationItem system)
        {
            this.textBoxLevel1.Text = system.User_Level1_Name;
            this.textBoxLevel2.Text = system.User_Level2_Name;
            this.textBoxLevel3.Text = system.User_Level3_Name;

            #region Level1
            this.checkBoxL1MainProductNo.Checked = group.Level1.IsMainDisplayProductNo;
            this.checkBoxL1MainWeightSet.Checked = group.Level1.IsMainDisplayWeightSetting;
            this.checkBoxL1MainClear.Checked = group.Level1.IsMainDisplayClear;
            this.checkBoxL1MainSubMenu.Checked = group.Level1.IsMainDisplaySubMenu;

            this.checkBoxL1MenuCalibration.Checked = group.Level1.IsMenuCalibration;
            this.checkBoxL1MenuConfiguration.Checked = group.Level1.IsMenuConfiguration;
            this.checkBoxL1MenuDataBackup.Checked = group.Level1.IsMenuDataBackup;
            this.checkBoxL1MenuStatistics.Checked = group.Level1.IsMenuStatistics;
            this.checkBoxL1MenuEquipment.Checked = group.Level1.IsMenuEquipment;
            this.checkBoxL1MenuInitialization.Checked = group.Level1.IsMenuInitialization;
            this.checkBoxL1MenuInformation.Checked = group.Level1.IsMenuInformation;
            this.checkBoxL1MenuIOTest.Checked = group.Level1.IsMenuIOTest;
            this.checkBoxL1MenuMotor.Checked = group.Level1.IsMenuMotor;
            this.checkBoxL1MenuSystem.Checked = group.Level1.IsMenuSystem;
            this.checkBoxL1MenuTime.Checked = group.Level1.IsMenuTime;
            this.checkBoxL1MenuUpdate.Checked = group.Level1.IsMenuUpdate;
            this.checkBoxL1MenuUser.Checked = group.Level1.IsMenuUser;
            #endregion

            #region Level2
            this.checkBoxL2MainProductNo.Checked = group.Level2.IsMainDisplayProductNo;
            this.checkBoxL2MainWeightSet.Checked = group.Level2.IsMainDisplayWeightSetting;
            this.checkBoxL2MainClear.Checked = group.Level2.IsMainDisplayClear;
            this.checkBoxL2MainSubMenu.Checked = group.Level2.IsMainDisplaySubMenu;

            this.checkBoxL2MenuCalibration.Checked = group.Level2.IsMenuCalibration;
            this.checkBoxL2MenuConfiguration.Checked = group.Level2.IsMenuConfiguration;
            this.checkBoxL2MenuDataBackup.Checked = group.Level2.IsMenuDataBackup;
            this.checkBoxL2MenuStatistics.Checked = group.Level2.IsMenuStatistics;
            this.checkBoxL2MenuEquipment.Checked = group.Level2.IsMenuEquipment;
            this.checkBoxL2MenuInitialization.Checked = group.Level2.IsMenuInitialization;
            this.checkBoxL2MenuInformation.Checked = group.Level2.IsMenuInformation;
            this.checkBoxL2MenuIOTest.Checked = group.Level2.IsMenuIOTest;
            this.checkBoxL2MenuMotor.Checked = group.Level2.IsMenuMotor;
            this.checkBoxL2MenuSystem.Checked = group.Level2.IsMenuSystem;
            this.checkBoxL2MenuTime.Checked = group.Level2.IsMenuTime;
            this.checkBoxL2MenuUpdate.Checked = group.Level2.IsMenuUpdate;
            this.checkBoxL2MenuUser.Checked = group.Level2.IsMenuUser;
            #endregion

            #region Level3
            this.checkBoxL3MainProductNo.Checked = group.Level3.IsMainDisplayProductNo;
            this.checkBoxL3MainWeightSet.Checked = group.Level3.IsMainDisplayWeightSetting;
            this.checkBoxL3MainClear.Checked = group.Level3.IsMainDisplayClear;
            this.checkBoxL3MainSubMenu.Checked = group.Level3.IsMainDisplaySubMenu;

            this.checkBoxL3MenuCalibration.Checked = group.Level3.IsMenuCalibration;
            this.checkBoxL3MenuConfiguration.Checked = group.Level3.IsMenuConfiguration;
            this.checkBoxL3MenuDataBackup.Checked = group.Level3.IsMenuDataBackup;
            this.checkBoxL3MenuStatistics.Checked = group.Level3.IsMenuStatistics;
            this.checkBoxL3MenuEquipment.Checked = group.Level3.IsMenuEquipment;
            this.checkBoxL3MenuInitialization.Checked = group.Level3.IsMenuInitialization;
            this.checkBoxL3MenuInformation.Checked = group.Level3.IsMenuInformation;
            this.checkBoxL3MenuIOTest.Checked = group.Level3.IsMenuIOTest;
            this.checkBoxL3MenuMotor.Checked = group.Level3.IsMenuMotor;
            this.checkBoxL3MenuSystem.Checked = group.Level3.IsMenuSystem;
            this.checkBoxL3MenuTime.Checked = group.Level3.IsMenuTime;
            this.checkBoxL3MenuUpdate.Checked = group.Level3.IsMenuUpdate;
            this.checkBoxL3MenuUser.Checked = group.Level3.IsMenuUser;
            #endregion

            #region NotLogin
            this.checkBoxNotLoginMainProductNo.Checked = group.NotLogin.IsMainDisplayProductNo;
            this.checkBoxNotLoginMainWeightSet.Checked = group.NotLogin.IsMainDisplayWeightSetting;
            this.checkBoxNotLoginMainClear.Checked = group.NotLogin.IsMainDisplayClear;
            this.checkBoxNotLoginMainSubMenu.Checked = group.NotLogin.IsMainDisplaySubMenu;

            this.checkBoxNotLoginMenuCalibration.Checked = group.NotLogin.IsMenuCalibration;
            this.checkBoxNotLoginMenuConfiguration.Checked = group.NotLogin.IsMenuConfiguration;
            this.checkBoxNotLoginMenuDataBackup.Checked = group.NotLogin.IsMenuDataBackup;
            this.checkBoxNotLoginMenuStatistics.Checked = group.NotLogin.IsMenuStatistics;
            this.checkBoxNotLoginMenuEquipment.Checked = group.NotLogin.IsMenuEquipment;
            this.checkBoxNotLoginMenuInitialization.Checked = group.NotLogin.IsMenuInitialization;
            this.checkBoxNotLoginMenuInformation.Checked = group.NotLogin.IsMenuInformation;
            this.checkBoxNotLoginMenuIOTest.Checked = group.NotLogin.IsMenuIOTest;
            this.checkBoxNotLoginMenuMotor.Checked = group.NotLogin.IsMenuMotor;
            this.checkBoxNotLoginMenuSystem.Checked = group.NotLogin.IsMenuSystem;
            this.checkBoxNotLoginMenuTime.Checked = group.NotLogin.IsMenuTime;
            this.checkBoxNotLoginMenuUpdate.Checked = group.NotLogin.IsMenuUpdate;
            this.checkBoxNotLoginMenuUser.Checked = group.NotLogin.IsMenuUser;
            #endregion
        }

        public void DisplayRefresh()
        {
            this.UpdateDisplay(this.ParentForm.CurrentUserGroup, this.ParentForm.SystemConfig);

            this.buttonSave.Visible = false;

            if (this.ParentForm.SystemConfig.CurrentUser.Status != DataStore.UserStatus.Developer)
            {
                for (int i = 0; i < this.CollectionLevel1Control.Count; i++)
                {
                    //this.CollectionLevel1Control[i].Location = new Point(this.CollectionLevel2Location[i].X, this.CollectionLevel2Location[i].Y);
                    //this.CollectionLevel2Control[i].Location = new Point(this.CollectionLevel3Location[i].X, this.CollectionLevel3Location[i].Y);

                    //this.CollectionLevel3Control[i].Visible = false;
                    this.CollectionNotLoginControl[i].Visible = false;
                }
            }
            else
            {
                for (int i = 0; i < this.CollectionLevel1Control.Count; i++)
                {
                    //this.CollectionLevel1Control[i].Location = new Point(this.CollectionLevel1Location[i].X, this.CollectionLevel1Location[i].Y);
                    //this.CollectionLevel2Control[i].Location = new Point(this.CollectionLevel2Location[i].X, this.CollectionLevel2Location[i].Y);

                    //this.CollectionLevel3Control[i].Visible = true;
                    this.CollectionNotLoginControl[i].Visible = true;
                }
            }

            // 현재 데이터 통계 메뉴가 없어서 Visible = false 처리함
            // 추후에 데이터 통계 메뉴 추가 되면 삭제
            this.labelTitleStatistics.Visible = false;
            this.checkBoxL1MenuStatistics.Visible = false;
            this.checkBoxL2MenuStatistics.Visible = false;
            this.checkBoxL3MenuStatistics.Visible = false;
            this.checkBoxNotLoginMenuStatistics.Visible = false;
        }
        #endregion

        #region Event Handler
        private void buttonBack_Click(object sender, EventArgs e)
        {
            this.ParentForm.ChildFormUserEditor.DisplayRefresh();
            ((FormMain)(Owner)).smartForm.Show((int)DataStore.FormStore.FormUserEditor);
        }
        private void buttonSave_Click(object sender, EventArgs e)
        {
            #region Level1
            this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayProductNo = this.checkBoxL1MainProductNo.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayWeightSetting = this.checkBoxL1MainWeightSet.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMainDisplayClear = this.checkBoxL1MainClear.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMainDisplaySubMenu = this.checkBoxL1MainSubMenu.Checked;

            this.ParentForm.CurrentUserGroup.Level1.IsMenuCalibration = this.checkBoxL1MenuCalibration.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuConfiguration = this.checkBoxL1MenuConfiguration.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuDataBackup = this.checkBoxL1MenuDataBackup.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuStatistics = this.checkBoxL1MenuStatistics.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuEquipment = this.checkBoxL1MenuEquipment.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuInitialization = this.checkBoxL1MenuInitialization.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuInformation = this.checkBoxL1MenuInformation.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuIOTest = this.checkBoxL1MenuIOTest.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuMotor = this.checkBoxL1MenuMotor.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuSystem = this.checkBoxL1MenuSystem.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuTime = this.checkBoxL1MenuTime.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuUpdate = this.checkBoxL1MenuUpdate.Checked;
            this.ParentForm.CurrentUserGroup.Level1.IsMenuUser = this.checkBoxL1MenuUser.Checked;
            #endregion

            #region Level2
            this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayProductNo = this.checkBoxL2MainProductNo.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayWeightSetting = this.checkBoxL2MainWeightSet.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMainDisplayClear = this.checkBoxL2MainClear.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMainDisplaySubMenu = this.checkBoxL2MainSubMenu.Checked;

            this.ParentForm.CurrentUserGroup.Level2.IsMenuCalibration = this.checkBoxL2MenuCalibration.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuConfiguration = this.checkBoxL2MenuConfiguration.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuDataBackup = this.checkBoxL2MenuDataBackup.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuStatistics = this.checkBoxL2MenuStatistics.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuEquipment = this.checkBoxL2MenuEquipment.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuInitialization = this.checkBoxL2MenuInitialization.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuInformation = this.checkBoxL2MenuInformation.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuIOTest = this.checkBoxL2MenuIOTest.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuMotor = this.checkBoxL2MenuMotor.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuSystem = this.checkBoxL2MenuSystem.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuTime = this.checkBoxL2MenuTime.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuUpdate = this.checkBoxL2MenuUpdate.Checked;
            this.ParentForm.CurrentUserGroup.Level2.IsMenuUser = this.checkBoxL2MenuUser.Checked;
            #endregion

            #region Level3
            this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayProductNo = this.checkBoxL3MainProductNo.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayWeightSetting = this.checkBoxL3MainWeightSet.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMainDisplayClear = this.checkBoxL3MainClear.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMainDisplaySubMenu = this.checkBoxL3MainSubMenu.Checked;

            this.ParentForm.CurrentUserGroup.Level3.IsMenuCalibration = this.checkBoxL3MenuCalibration.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuConfiguration = this.checkBoxL3MenuConfiguration.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuDataBackup = this.checkBoxL3MenuDataBackup.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuStatistics = this.checkBoxL3MenuStatistics.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuEquipment = this.checkBoxL3MenuEquipment.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuInitialization = this.checkBoxL3MenuInitialization.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuInformation = this.checkBoxL3MenuInformation.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuIOTest = this.checkBoxL3MenuIOTest.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuMotor = this.checkBoxL3MenuMotor.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuSystem = this.checkBoxL3MenuSystem.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuTime = this.checkBoxL3MenuTime.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuUpdate = this.checkBoxL3MenuUpdate.Checked;
            this.ParentForm.CurrentUserGroup.Level3.IsMenuUser = this.checkBoxL3MenuUser.Checked;
            #endregion

            #region NotLogin
            this.ParentForm.CurrentUserGroup.NotLogin.IsMainDisplayProductNo = this.checkBoxNotLoginMainProductNo.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMainDisplayWeightSetting = this.checkBoxNotLoginMainWeightSet.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMainDisplayClear = this.checkBoxNotLoginMainClear.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMainDisplaySubMenu = this.checkBoxNotLoginMainSubMenu.Checked;

            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuCalibration = this.checkBoxNotLoginMenuCalibration.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuCommunication = this.checkBoxNotLoginMenuConfiguration.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuConfiguration = this.checkBoxNotLoginMenuConfiguration.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuDataBackup = this.checkBoxNotLoginMenuDataBackup.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuStatistics = this.checkBoxNotLoginMenuStatistics.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuEquipment = this.checkBoxNotLoginMenuEquipment.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuInitialization = this.checkBoxNotLoginMenuInitialization.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuInformation = this.checkBoxNotLoginMenuInformation.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuIOTest = this.checkBoxNotLoginMenuIOTest.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuMotor = this.checkBoxNotLoginMenuMotor.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuSystem = this.checkBoxNotLoginMenuSystem.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuTime = this.checkBoxNotLoginMenuTime.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuUpdate = this.checkBoxNotLoginMenuUpdate.Checked;
            this.ParentForm.CurrentUserGroup.NotLogin.IsMenuUser = this.checkBoxNotLoginMenuUser.Checked;
            #endregion

            this.ParentForm.SaveUserGroupFile(this.ParentForm.CurrentUserGroup);

            this.buttonSave.Visible = false;
        }

        private void buttonEdit_Click(object sender, EventArgs e)
        {
            SmartButton button = sender as SmartButton;

            this.smartKeyboard.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NORMAL;
            this.smartKeyboard.Location = new Point(8, 0);
            this.smartKeyboard.Size = new Size(695, 377);
            this.smartKeyboard.KeyFillColor = Color.Black;
            this.smartKeyboard.BackColor = Color.FromArgb(30, 30, 30);

            if (button == this.buttonEditLevel1)
            {
                this.BeforeTextBox1 = this.textBoxLevel1.Text;
                this.smartKeyboard.TargetInputObject = this.textBoxLevel1;
                this.textBoxLevel1.Select(this.textBoxLevel1.Text.Length, 0);
            }
            else if (button == this.buttonEditLevel2)
            {
                this.BeforeTextBox2 = this.textBoxLevel2.Text;
                this.smartKeyboard.TargetInputObject = this.textBoxLevel2;
                this.textBoxLevel2.Select(this.textBoxLevel2.Text.Length, 0);
            }
            else if (button == this.buttonEditLevel3)
            {
                this.BeforeTextBox3 = this.textBoxLevel3.Text;
                this.smartKeyboard.TargetInputObject = this.textBoxLevel3;
                this.textBoxLevel3.Select(this.textBoxLevel3.Text.Length, 0);
            }

            this.smartKeyboard.Show();
        }

        private void labelTitle1_Click(object sender, EventArgs e)
        {
            if (this.ParentForm.SystemConfig.CurrentUser.Status == DataStore.UserStatus.Developer)
            {
                this.checkBoxL1MainProductNo.Checked = true;
                this.checkBoxL1MainWeightSet.Checked = true;
                this.checkBoxL1MainClear.Checked = true;
                this.checkBoxL1MainSubMenu.Checked = true;

                this.checkBoxL1MenuInformation.Checked = true;
                this.checkBoxL1MenuDataBackup.Checked = true;
                this.checkBoxL1MenuCommunication.Checked = true;
                this.checkBoxL1MenuConfiguration.Checked = true;
                this.checkBoxL1MenuCalibration.Checked = true;
                this.checkBoxL1MenuSystem.Checked = true;
                this.checkBoxL1MenuMotor.Checked = true;
                this.checkBoxL1MenuIOTest.Checked = true;
                this.checkBoxL1MenuUpdate.Checked = true;
                this.checkBoxL1MenuInitialization.Checked = true;
                this.checkBoxL1MenuUser.Checked = true;
                this.checkBoxL1MenuEquipment.Checked = true;
                this.checkBoxL1MenuStatistics.Checked = true;
                this.checkBoxL1MenuTime.Checked = true;

                this.buttonSave.Visible = true;
            }
        }
        private void labelTitle2_Click(object sender, EventArgs e)
        {
            if (this.ParentForm.SystemConfig.CurrentUser.Status == DataStore.UserStatus.Developer)
            {
                this.checkBoxL2MainProductNo.Checked = true;
                this.checkBoxL2MainWeightSet.Checked = true;
                this.checkBoxL2MainClear.Checked = true;
                this.checkBoxL2MainSubMenu.Checked = true;

                this.checkBoxL2MenuInformation.Checked = true;
                this.checkBoxL2MenuDataBackup.Checked = true;
                this.checkBoxL2MenuCommunication.Checked = true;
                this.checkBoxL2MenuConfiguration.Checked = true;
                this.checkBoxL2MenuCalibration.Checked = true;
                this.checkBoxL2MenuSystem.Checked = true;
                this.checkBoxL2MenuMotor.Checked = true;
                this.checkBoxL2MenuIOTest.Checked = true;
                this.checkBoxL2MenuUpdate.Checked = true;
                this.checkBoxL2MenuInitialization.Checked = true;
                this.checkBoxL2MenuUser.Checked = true;
                this.checkBoxL2MenuEquipment.Checked = true;
                this.checkBoxL2MenuStatistics.Checked = true;
                this.checkBoxL2MenuTime.Checked = true;

                this.buttonSave.Visible = true;
            }
        }
        private void labelTitle3_Click(object sender, EventArgs e)
        {
            if (this.ParentForm.SystemConfig.CurrentUser.Status == DataStore.UserStatus.Developer)
            {
                this.checkBoxL3MainProductNo.Checked = true;
                this.checkBoxL3MainWeightSet.Checked = true;
                this.checkBoxL3MainClear.Checked = true;
                this.checkBoxL3MainSubMenu.Checked = true;

                this.checkBoxL3MenuInformation.Checked = true;
                this.checkBoxL3MenuDataBackup.Checked = true;
                this.checkBoxL3MenuCommunication.Checked = true;
                this.checkBoxL3MenuConfiguration.Checked = true;
                this.checkBoxL3MenuCalibration.Checked = true;
                this.checkBoxL3MenuSystem.Checked = true;
                this.checkBoxL3MenuMotor.Checked = true;
                this.checkBoxL3MenuIOTest.Checked = true;
                this.checkBoxL3MenuUpdate.Checked = true;
                this.checkBoxL3MenuInitialization.Checked = true;
                this.checkBoxL3MenuUser.Checked = true;
                this.checkBoxL3MenuEquipment.Checked = true;
                this.checkBoxL3MenuStatistics.Checked = true;
                this.checkBoxL3MenuTime.Checked = true;

                this.buttonSave.Visible = true;
            }
        }
        private void labelTitle4_Click(object sender, EventArgs e)
        {
            if (this.ParentForm.SystemConfig.CurrentUser.Status == DataStore.UserStatus.Developer)
            {
                this.checkBoxNotLoginMainProductNo.Checked = true;
                this.checkBoxNotLoginMainWeightSet.Checked = true;
                this.checkBoxNotLoginMainClear.Checked = true;
                this.checkBoxNotLoginMainSubMenu.Checked = true;

                this.checkBoxNotLoginMenuInformation.Checked = true;
                this.checkBoxNotLoginMenuDataBackup.Checked = true;
                this.checkBoxNotLoginMenuCommunication.Checked = true;
                this.checkBoxNotLoginMenuConfiguration.Checked = true;
                this.checkBoxNotLoginMenuCalibration.Checked = true;
                this.checkBoxNotLoginMenuSystem.Checked = true;
                this.checkBoxNotLoginMenuMotor.Checked = true;
                this.checkBoxNotLoginMenuIOTest.Checked = true;
                this.checkBoxNotLoginMenuUpdate.Checked = true;
                this.checkBoxNotLoginMenuInitialization.Checked = true;
                this.checkBoxNotLoginMenuUser.Checked = true;
                this.checkBoxNotLoginMenuEquipment.Checked = true;
                this.checkBoxNotLoginMenuStatistics.Checked = true;
                this.checkBoxNotLoginMenuTime.Checked = true;

                this.buttonSave.Visible = true;
            }
        }

        private void checkBox_Click(object sender, EventArgs e)
        {
            if (this.buttonSave.Visible == false)
                this.buttonSave.Visible = true;
        }
        #endregion

        private void smartKeyboard_OnXKeyClick(object sender, EventArgs e)
        {

        }
    }
}