﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.IO;

namespace INT69DB_2A_ImageDll
{
    public class ImageDll
    {
        public enum ButtonImages
        {
            #region English
            engBigEnterDown,
            engBigEnterUp,
            engBypassCountDown,
            engBypassCountUp,
            engCancelDown,
            engCancelUp,
            engCopyDown,
            engCopyUp,
            engEnterDown,
            engEnterUp,
            engFormCalibrationCancelDisable,
            engFormCalibrationCancelDown,
            engFormCalibrationCancelUp,
            engFormCalibrationStartDisable,
            engFormCalibrationStartDown,
            engFormCalibrationStartUp,
            engFormCalibrationWeightDisable,
            engFormCalibrationWeightDown,
            engFormCalibrationWeightUp,
            engFormMainDisplayLoginDisable,
            engFormMainDisplayLoginDown,
            engFormMainDisplayLoginUp,
            engFormMainDisplayLogoutDisable,
            engFormMainDisplayLogoutDown,
            engFormMainDisplayLogoutUp,
            engFormMainDisplayMenuBigDisable,
            engFormMainDisplayMenuBigDown,
            engFormMainDisplayMenuBigUp,
            engFormMainDisplayMenuDisable,
            engFormMainDisplayMenuDown,
            engFormMainDisplayMenuUp,
            engFormMainOverDisable,
            engFormMainOverDown,
            engFormMainOverUp,
            engFormMainPassDisable,
            engFormMainPassDown,
            engFormMainPassUp,
            engFormMainTareDisable,
            engFormMainTareDown,
            engFormMainTareUp,
            engFormMainUnderDisable,
            engFormMainUnderDown,
            engFormMainUnderUp,
            engFormMenuCalibrationDisable,
            engFormMenuCalibrationDown,
            engFormMenuCalibrationUp,
            engFormMenuCommunicationDisable,
            engFormMenuCommunicationDown,
            engFormMenuCommunicationUp,
            engFormMenuConfigurationDisable,
            engFormMenuConfigurationDown,
            engFormMenuConfigurationUp,
            engFormMenuDataBackupDisable,
            engFormMenuDataBackupDown,
            engFormMenuDataBackupUp,
            engFormMenuDataViewerDisable,
            engFormMenuDataViewerDown,
            engFormMenuDataViewerUp,
            engFormMenuEquipmentDisable,
            engFormMenuEquipmentDown,
            engFormMenuEquipmentUp,
            engFormMenuInformationDisable,
            engFormMenuInformationDown,
            engFormMenuInformationUp,
            engFormMenuInitializationDisable,
            engFormMenuInitializationDown,
            engFormMenuInitializationUp,
            engFormMenuIOTestDisable,
            engFormMenuIOTestDown,
            engFormMenuIOTestUp,
            engFormMenuMotorDisable,
            engFormMenuMotorDown,
            engFormMenuMotorUp,
            engFormMenuStatisticsDisable,
            engFormMenuStatisticsDown,
            engFormMenuStatisticsUp,
            engFormMenuSystemDisable,
            engFormMenuSystemDown,
            engFormMenuSystemUp,
            engFormMenuTestDisable,
            engFormMenuTestDown,
            engFormMenuTestUp,
            engFormMenuTimeDisable,
            engFormMenuTimeDown,
            engFormMenuTimeUp,
            engFormMenuUpdateDisable,
            engFormMenuUpdateDown,
            engFormMenuUpdateUp,
            engFormMenuUserDisable,
            engFormMenuUserDown,
            engFormMenuUserUp,
            engFormMotorSetting,
            engFormSystemSettingNoDown,
            engFormSystemSettingNoUp,
            engFormSystemSettingOverDown,
            engFormSystemSettingOverUp,
            engFormSystemSettingPassDown,
            engFormSystemSettingPassUp,
            engFormSystemSettingTareDown,
            engFormSystemSettingTareUp,
            engFormSystemSettingUnderDown,
            engFormSystemSettingUnderUp,
            engPasteAllDown,
            engPasteAllUp,
            engPasteDown,
            engPasteUp,
            engMainLoginDisable,
            engMainLoginDown,
            engMainLoginUp,
            engMainCancelDisable,
            engMainCancelDown,
            engMainCancelUp,
            #endregion

            #region Chinese
            chnBackgroundUserLogin,
            chnBigEnterDown,
            chnBigEnterUp,
            chnBypassCountDown,
            chnBypassCountUp,
            chnBypassOccasionDown,
            chnBypassOccasionUp,
            chnCancelDown,
            chnCancelUp,
            chnCopyDown,
            chnCopyUp,
            chnDisable,
            chnEnable,
            chnEnterDown,
            chnEnterUp,
            chnFormCalibrationCancelDisable,
            chnFormCalibrationCancelDown,
            chnFormCalibrationCancelUp,
            chnFormCalibrationStartDisable,
            chnFormCalibrationStartDown,
            chnFormCalibrationStartUp,
            chnFormCalibrationWeightDisable,
            chnFormCalibrationWeightDown,
            chnFormCalibrationWeightUp,
            chnFormMainDisplayLoginDisable,
            chnFormMainDisplayLoginDown,
            chnFormMainDisplayLoginUp,
            chnFormMainDisplayLogoutDisable,
            chnFormMainDisplayLogoutDown,
            chnFormMainDisplayLogoutUp,
            chnFormMainDisplayMenuBigDisable,
            chnFormMainDisplayMenuBigDown,
            chnFormMainDisplayMenuBigUp,
            chnFormMainDisplayMenuDisable,
            chnFormMainDisplayMenuDown,
            chnFormMainDisplayMenuUp,
            chnFormMainOverDisable,
            chnFormMainOverDown,
            chnFormMainOverUp,
            chnFormMainPassDisable,
            chnFormMainPassDown,
            chnFormMainPassUp,
            chnFormMainTareDisable,
            chnFormMainTareDown,
            chnFormMainTareUp,
            chnFormMainUnderDisable,
            chnFormMainUnderDown,
            chnFormMainUnderUp,
            chnFormMenuCalibrationDisable,
            chnFormMenuCalibrationDown,
            chnFormMenuCalibrationUp,
            chnFormMenuCommunicationDisable,
            chnFormMenuCommunicationDown,
            chnFormMenuCommunicationUp,
            chnFormMenuConfigurationDisable,
            chnFormMenuConfigurationDown,
            chnFormMenuConfigurationUp,
            chnFormMenuDataBackupDisable,
            chnFormMenuDataBackupDown,
            chnFormMenuDataBackupUp,
            chnFormMenuDataViewerDisable,
            chnFormMenuDataViewerDown,
            chnFormMenuDataViewerUp,
            chnFormMenuEquipmentDisable,
            chnFormMenuEquipmentDown,
            chnFormMenuEquipmentUp,
            chnFormMenuInformationDisable,
            chnFormMenuInformationDown,
            chnFormMenuInformationUp,
            chnFormMenuInitializationDisable,
            chnFormMenuInitializationDown,
            chnFormMenuInitializationUp,
            chnFormMenuIOTestDisable,
            chnFormMenuIOTestDown,
            chnFormMenuIOTestUp,
            chnFormMenuMotorDisable,
            chnFormMenuMotorDown,
            chnFormMenuMotorUp,
            chnFormMenuStatisticsDisable,
            chnFormMenuStatisticsDown,
            chnFormMenuStatisticsUp,
            chnFormMenuSystemDisable,
            chnFormMenuSystemDown,
            chnFormMenuSystemUp,
            chnFormMenuTestDisable,
            chnFormMenuTestDown,
            chnFormMenuTestUp,
            chnFormMenuTimeDisable,
            chnFormMenuTimeDown,
            chnFormMenuTimeUp,
            chnFormMenuUpdateDisable,
            chnFormMenuUpdateDown,
            chnFormMenuUpdateUp,
            chnFormMenuUserDisable,
            chnFormMenuUserDown,
            chnFormMenuUserUp,
            chnFormMotorSetting,
            chnFormSystemSettingNoDown,
            chnFormSystemSettingNoUp,
            chnFormSystemSettingOverDown,
            chnFormSystemSettingOverUp,
            chnFormSystemSettingPassDown,
            chnFormSystemSettingPassUp,
            chnFormSystemSettingTareDown,
            chnFormSystemSettingTareUp,
            chnFormSystemSettingUnderDown,
            chnFormSystemSettingUnderUp,
            chnPasteAllDown,
            chnPasteAllUp,
            chnPasteDown,
            chnPasteUp,
            chnMainCancelDisable,
            chnMainCancelDown,
            chnMainCancelUp,
            chnMainLoginDisable,
            chnMainLoginDown,
            chnMainLoginUp,
            #endregion

            #region Korean
            korBackgroundUserLogin,
            korFormMainDisplayMenuBigDisable,
            korFormMainDisplayMenuBigDown,
            korFormMainDisplayMenuBigUp,
            korFormMenuCalibrationDisable,
            korFormMenuCalibrationDown,
            korFormMenuCalibrationUp,
            korFormMenuCommunicationDisable,
            korFormMenuCommunicationDown,
            korFormMenuCommunicationUp,
            korFormMenuConfigurationDisable,
            korFormMenuConfigurationDown,
            korFormMenuConfigurationUp,
            korFormMenuDataBackupDisable,
            korFormMenuDataBackupDown,
            korFormMenuDataBackupUp,
            korFormMenuDataViewerDisable,
            korFormMenuDataViewerDown,
            korFormMenuDataViewerUp,
            korFormMenuEquipmentDisable,
            korFormMenuEquipmentDown,
            korFormMenuEquipmentUp,
            korFormMenuInformationDisable,
            korFormMenuInformationDown,
            korFormMenuInformationUp,
            korFormMenuInitializationDisable,
            korFormMenuInitializationDown,
            korFormMenuInitializationUp,
            korFormMenuIOTestDisable,
            korFormMenuIOTestDown,
            korFormMenuIOTestUp,
            korFormMenuMotorDisable,
            korFormMenuMotorDown,
            korFormMenuMotorUp,
            korFormMenuStatisticsDisable,
            korFormMenuStatisticsDown,
            korFormMenuStatisticsUp,
            korFormMenuSystemDisable,
            korFormMenuSystemDown,
            korFormMenuSystemUp,
            korFormMenuTestDisable,
            korFormMenuTestDown,
            korFormMenuTestUp,
            korFormMenuTimeDisable,
            korFormMenuTimeDown,
            korFormMenuTimeUp,
            korFormMenuUpdateDisable,
            korFormMenuUpdateDown,
            korFormMenuUpdateUp,
            korFormMenuUserDisable,
            korFormMenuUserDown,
            korFormMenuUserUp,
            #endregion
        }

        public Bitmap GetImage(ButtonImages image)
        {
            Bitmap bt;

            switch (image)
            {
                #region 영문
                case ButtonImages.engBigEnterDown:
                    bt = new Bitmap(Resource1.engBigEnterDown);
                    break;
                case ButtonImages.engBigEnterUp:
                    bt = new Bitmap(Resource1.engBigEnterUp);
                    break;
                case ButtonImages.engBypassCountDown:
                    bt = new Bitmap(Resource1.engBypassCountDown);
                    break;
                case ButtonImages.engBypassCountUp:
                    bt = new Bitmap(Resource1.engBypassCountUp);
                    break;
                case ButtonImages.engCancelDown:
                    bt = new Bitmap(Resource1.engCancelDown);
                    break;
                case ButtonImages.engCancelUp:
                    bt = new Bitmap(Resource1.engCancelUp);
                    break;
                case ButtonImages.engCopyDown:
                    bt = new Bitmap(Resource1.engCopyDown);
                    break;
                case ButtonImages.engCopyUp:
                    bt = new Bitmap(Resource1.engCopyUp);
                    break;
                case ButtonImages.engEnterDown:
                    bt = new Bitmap(Resource1.engEnterDown);
                    break;
                case ButtonImages.engEnterUp:
                    bt = new Bitmap(Resource1.engEnterUp);
                    break;
                case ButtonImages.engFormCalibrationCancelDisable:
                    bt = new Bitmap(Resource1.engFormCalibrationCancelDisable);
                    break;
                case ButtonImages.engFormCalibrationCancelDown:
                    bt = new Bitmap(Resource1.engFormCalibrationCancelDown);
                    break;
                case ButtonImages.engFormCalibrationCancelUp:
                    bt = new Bitmap(Resource1.engFormCalibrationCancelUp);
                    break;
                case ButtonImages.engFormCalibrationStartDisable:
                    bt = new Bitmap(Resource1.engFormCalibrationStartDisable);
                    break;
                case ButtonImages.engFormCalibrationStartDown:
                    bt = new Bitmap(Resource1.engFormCalibrationStartDown);
                    break;
                case ButtonImages.engFormCalibrationStartUp:
                    bt = new Bitmap(Resource1.engFormCalibrationStartUp);
                    break;
                case ButtonImages.engFormCalibrationWeightDisable:
                    bt = new Bitmap(Resource1.engFormCalibrationWeightDisable);
                    break;
                case ButtonImages.engFormCalibrationWeightDown:
                    bt = new Bitmap(Resource1.engFormCalibrationWeightDown);
                    break;
                case ButtonImages.engFormCalibrationWeightUp:
                    bt = new Bitmap(Resource1.engFormCalibrationWeightUp);
                    break;
                case ButtonImages.engFormMainDisplayLoginDisable:
                    bt = new Bitmap(Resource1.engFormMainDisplayLoginDisable);
                    break;
                case ButtonImages.engFormMainDisplayLoginDown:
                    bt = new Bitmap(Resource1.engFormMainDisplayLoginDown);
                    break;
                case ButtonImages.engFormMainDisplayLoginUp:
                    bt = new Bitmap(Resource1.engFormMainDisplayLoginUp);
                    break;
                case ButtonImages.engFormMainDisplayLogoutDisable:
                    bt = new Bitmap(Resource1.engFormMainDisplayLogoutDisable);
                    break;
                case ButtonImages.engFormMainDisplayLogoutDown:
                    bt = new Bitmap(Resource1.engFormMainDisplayLogoutDown);
                    break;
                case ButtonImages.engFormMainDisplayLogoutUp:
                    bt = new Bitmap(Resource1.engFormMainDisplayLogoutUp);
                    break;
                case ButtonImages.engFormMainDisplayMenuBigDisable:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuBigDisable);
                    break;
                case ButtonImages.engFormMainDisplayMenuBigDown:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuBigDown);
                    break;
                case ButtonImages.engFormMainDisplayMenuBigUp:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuBigUp);
                    break;
                case ButtonImages.engFormMainDisplayMenuDisable:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuDisable);
                    break;
                case ButtonImages.engFormMainDisplayMenuDown:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuDown);
                    break;
                case ButtonImages.engFormMainDisplayMenuUp:
                    bt = new Bitmap(Resource1.engFormMainDisplayMenuUp);
                    break;
                case ButtonImages.engFormMainOverDisable:
                    bt = new Bitmap(Resource1.engFormMainOverDisable);
                    break;
                case ButtonImages.engFormMainOverDown:
                    bt = new Bitmap(Resource1.engFormMainOverDown);
                    break;
                case ButtonImages.engFormMainOverUp:
                    bt = new Bitmap(Resource1.engFormMainOverUp);
                    break;
                case ButtonImages.engFormMainPassDisable:
                    bt = new Bitmap(Resource1.engFormMainPassDisable);
                    break;
                case ButtonImages.engFormMainPassDown:
                    bt = new Bitmap(Resource1.engFormMainPassDown);
                    break;
                case ButtonImages.engFormMainPassUp:
                    bt = new Bitmap(Resource1.engFormMainPassUp);
                    break;
                case ButtonImages.engFormMainTareDisable:
                    bt = new Bitmap(Resource1.engFormMainTareDisable);
                    break;
                case ButtonImages.engFormMainTareDown:
                    bt = new Bitmap(Resource1.engFormMainTareDown);
                    break;
                case ButtonImages.engFormMainTareUp:
                    bt = new Bitmap(Resource1.engFormMainTareUp);
                    break;
                case ButtonImages.engFormMainUnderDisable:
                    bt = new Bitmap(Resource1.engFormMainUnderDisable);
                    break;
                case ButtonImages.engFormMainUnderDown:
                    bt = new Bitmap(Resource1.engFormMainUnderDown);
                    break;
                case ButtonImages.engFormMainUnderUp:
                    bt = new Bitmap(Resource1.engFormMainUnderUp);
                    break;
                #region 메뉴
                case ButtonImages.engFormMenuCalibrationDisable:
                    bt = new Bitmap(Resource1.engFormMenuCalibrationDisable);
                    break;
                case ButtonImages.engFormMenuCalibrationDown:
                    bt = new Bitmap(Resource1.engFormMenuCalibrationDown);
                    break;
                case ButtonImages.engFormMenuCalibrationUp:
                    bt = new Bitmap(Resource1.engFormMenuCalibrationUp);
                    break;
                case ButtonImages.engFormMenuCommunicationDisable:
                    bt = new Bitmap(Resource1.engFormMenuCommunicationDisable);
                    break;
                case ButtonImages.engFormMenuCommunicationDown:
                    bt = new Bitmap(Resource1.engFormMenuCommunicationDown);
                    break;
                case ButtonImages.engFormMenuCommunicationUp:
                    bt = new Bitmap(Resource1.engFormMenuCommunicationUp);
                    break;
                case ButtonImages.engFormMenuConfigurationDisable:
                    bt = new Bitmap(Resource1.engFormMenuConfigurationDisable);
                    break;
                case ButtonImages.engFormMenuConfigurationDown:
                    bt = new Bitmap(Resource1.engFormMenuConfigurationDown);
                    break;
                case ButtonImages.engFormMenuConfigurationUp:
                    bt = new Bitmap(Resource1.engFormMenuConfigurationUp);
                    break;
                case ButtonImages.engFormMenuDataBackupDisable:
                    bt = new Bitmap(Resource1.engFormMenuDataBackupDisable);
                    break;
                case ButtonImages.engFormMenuDataBackupDown:
                    bt = new Bitmap(Resource1.engFormMenuDataBackupDown);
                    break;
                case ButtonImages.engFormMenuDataBackupUp:
                    bt = new Bitmap(Resource1.engFormMenuDataBackupUp);
                    break;
                case ButtonImages.engFormMenuDataViewerDisable:
                    bt = new Bitmap(Resource1.engFormMenuDataViewerDisable);
                    break;
                case ButtonImages.engFormMenuDataViewerDown:
                    bt = new Bitmap(Resource1.engFormMenuDataViewerDown);
                    break;
                case ButtonImages.engFormMenuDataViewerUp:
                    bt = new Bitmap(Resource1.engFormMenuDataViewerUp);
                    break;
                case ButtonImages.engFormMenuEquipmentDisable:
                    bt = new Bitmap(Resource1.engFormMenuEquipmentDisable);
                    break;
                case ButtonImages.engFormMenuEquipmentDown:
                    bt = new Bitmap(Resource1.engFormMenuEquipmentDown);
                    break;
                case ButtonImages.engFormMenuEquipmentUp:
                    bt = new Bitmap(Resource1.engFormMenuEquipmentUp);
                    break;
                case ButtonImages.engFormMenuInformationDisable:
                    bt = new Bitmap(Resource1.engFormMenuInformationDisable);
                    break;
                case ButtonImages.engFormMenuInformationDown:
                    bt = new Bitmap(Resource1.engFormMenuInformationDown);
                    break;
                case ButtonImages.engFormMenuInformationUp:
                    bt = new Bitmap(Resource1.engFormMenuInformationUp);
                    break;
                case ButtonImages.engFormMenuInitializationDisable:
                    bt = new Bitmap(Resource1.engFormMenuInitializationDisable);
                    break;
                case ButtonImages.engFormMenuInitializationDown:
                    bt = new Bitmap(Resource1.engFormMenuInitializationDown);
                    break;
                case ButtonImages.engFormMenuInitializationUp:
                    bt = new Bitmap(Resource1.engFormMenuInitializationUp);
                    break;
                case ButtonImages.engFormMenuIOTestDisable:
                    bt = new Bitmap(Resource1.engFormMenuIOTestDisable);
                    break;
                case ButtonImages.engFormMenuIOTestDown:
                    bt = new Bitmap(Resource1.engFormMenuIOTestDown);
                    break;
                case ButtonImages.engFormMenuIOTestUp:
                    bt = new Bitmap(Resource1.engFormMenuIOTestUp);
                    break;
                case ButtonImages.engFormMenuMotorDisable:
                    bt = new Bitmap(Resource1.engFormMenuMotorDisable);
                    break;
                case ButtonImages.engFormMenuMotorDown:
                    bt = new Bitmap(Resource1.engFormMenuMotorDown);
                    break;
                case ButtonImages.engFormMenuMotorUp:
                    bt = new Bitmap(Resource1.engFormMenuMotorUp);
                    break;
                case ButtonImages.engFormMenuStatisticsDisable:
                    bt = new Bitmap(Resource1.engFormMenuStatisticsDisable);
                    break;
                case ButtonImages.engFormMenuStatisticsDown:
                    bt = new Bitmap(Resource1.engFormMenuStatisticsDown);
                    break;
                case ButtonImages.engFormMenuStatisticsUp:
                    bt = new Bitmap(Resource1.engFormMenuStatisticsUp);
                    break;
                case ButtonImages.engFormMenuSystemDisable:
                    bt = new Bitmap(Resource1.engFormMenuSystemDisable);
                    break;
                case ButtonImages.engFormMenuSystemDown:
                    bt = new Bitmap(Resource1.engFormMenuSystemDown);
                    break;
                case ButtonImages.engFormMenuSystemUp:
                    bt = new Bitmap(Resource1.engFormMenuSystemUp);
                    break;
                case ButtonImages.engFormMenuTestDisable:
                    bt = new Bitmap(Resource1.engFormMenuTestDisable);
                    break;
                case ButtonImages.engFormMenuTestDown:
                    bt = new Bitmap(Resource1.engFormMenuTestDown);
                    break;
                case ButtonImages.engFormMenuTestUp:
                    bt = new Bitmap(Resource1.engFormMenuTestUp);
                    break;
                case ButtonImages.engFormMenuTimeDisable:
                    bt = new Bitmap(Resource1.engFormMenuTimeDisable);
                    break;
                case ButtonImages.engFormMenuTimeDown:
                    bt = new Bitmap(Resource1.engFormMenuTimeDown);
                    break;
                case ButtonImages.engFormMenuTimeUp:
                    bt = new Bitmap(Resource1.engFormMenuTimeUp);
                    break;
                case ButtonImages.engFormMenuUpdateDisable:
                    bt = new Bitmap(Resource1.engFormMenuUpdateDisable);
                    break;
                case ButtonImages.engFormMenuUpdateDown:
                    bt = new Bitmap(Resource1.engFormMenuUpdateDown);
                    break;
                case ButtonImages.engFormMenuUpdateUp:
                    bt = new Bitmap(Resource1.engFormMenuUpdateUp);
                    break;
                case ButtonImages.engFormMenuUserDisable:
                    bt = new Bitmap(Resource1.engFormMenuUserDisable);
                    break;
                case ButtonImages.engFormMenuUserDown:
                    bt = new Bitmap(Resource1.engFormMenuUserDown);
                    break;
                case ButtonImages.engFormMenuUserUp:
                    bt = new Bitmap(Resource1.engFormMenuUserUp);
                    break; 
                #endregion
                case ButtonImages.engFormSystemSettingNoDown:
                    bt = new Bitmap(Resource1.engFormSystemSettingNoDown);
                    break;
                case ButtonImages.engFormSystemSettingNoUp:
                    bt = new Bitmap(Resource1.engFormSystemSettingNoUp);
                    break;
                case ButtonImages.engFormSystemSettingOverDown:
                    bt = new Bitmap(Resource1.engFormSystemSettingOverDown);
                    break;
                case ButtonImages.engFormSystemSettingOverUp:
                    bt = new Bitmap(Resource1.engFormSystemSettingOverUp);
                    break;
                case ButtonImages.engFormSystemSettingPassDown:
                    bt = new Bitmap(Resource1.engFormSystemSettingPassDown);
                    break;
                case ButtonImages.engFormSystemSettingPassUp:
                    bt = new Bitmap(Resource1.engFormSystemSettingPassUp);
                    break;
                case ButtonImages.engFormSystemSettingTareDown:
                    bt = new Bitmap(Resource1.engFormSystemSettingTareDown);
                    break;
                case ButtonImages.engFormSystemSettingTareUp:
                    bt = new Bitmap(Resource1.engFormSystemSettingTareUp);
                    break;
                case ButtonImages.engFormSystemSettingUnderDown:
                    bt = new Bitmap(Resource1.engFormSystemSettingUnderDown);
                    break;
                case ButtonImages.engFormSystemSettingUnderUp:
                    bt = new Bitmap(Resource1.engFormSystemSettingUnderUp);
                    break;
                case ButtonImages.engPasteAllDown:
                    bt = new Bitmap(Resource1.engPasteAllDown);
                    break;
                case ButtonImages.engPasteAllUp:
                    bt = new Bitmap(Resource1.engPasteAllUp);
                    break;
                case ButtonImages.engPasteDown:
                    bt = new Bitmap(Resource1.engPasteDown);
                    break;
                case ButtonImages.engPasteUp:
                    bt = new Bitmap(Resource1.engPasteUp);
                    break;
                case ButtonImages.engMainLoginDisable:
                    bt = new Bitmap(Resource1.engMainLoginDisable);
                    break;
                case ButtonImages.engMainLoginDown:
                    bt = new Bitmap(Resource1.engMainLoginDown);
                    break;
                case ButtonImages.engMainLoginUp:
                    bt = new Bitmap(Resource1.engMainLoginUp);
                    break;
                case ButtonImages.engMainCancelDisable:
                    bt = new Bitmap(Resource1.engMainCancelDisable);
                    break;
                case ButtonImages.engMainCancelDown:
                    bt = new Bitmap(Resource1.engMainCancelDown);
                    break;
                case ButtonImages.engMainCancelUp:
                    bt = new Bitmap(Resource1.engMainCancelUp);
                    break;
                #endregion
                #region 중문
                case ButtonImages.chnBackgroundUserLogin:
                    bt = new Bitmap(Resource1.chnBackgroundUserLogin);
                    break;
                case ButtonImages.chnBigEnterDown:
                    bt = new Bitmap(Resource1.chnBigEnterDown);
                    break;
                case ButtonImages.chnBigEnterUp:
                    bt = new Bitmap(Resource1.chnBigEnterUp);
                    break;
                case ButtonImages.chnBypassCountDown:
                    bt = new Bitmap(Resource1.chnBypassCountDown);
                    break;
                case ButtonImages.chnBypassCountUp:
                    bt = new Bitmap(Resource1.chnBypassCountUp);
                    break;
                case ButtonImages.chnBypassOccasionDown:
                    bt = new Bitmap(Resource1.chnBypassOccasionDown);
                    break;
                case ButtonImages.chnBypassOccasionUp:
                    bt = new Bitmap(Resource1.chnBypassOccasionUp);
                    break;
                case ButtonImages.chnCancelDown:
                    bt = new Bitmap(Resource1.chnCancelDown);
                    break;
                case ButtonImages.chnCancelUp:
                    bt = new Bitmap(Resource1.chnCancelUp);
                    break;
                case ButtonImages.chnCopyDown:
                    bt = new Bitmap(Resource1.chnCopyDown);
                    break;
                case ButtonImages.chnCopyUp:
                    bt = new Bitmap(Resource1.chnCopyUp);
                    break;
                case ButtonImages.chnDisable:
                    bt = new Bitmap(Resource1.chnDisable);
                    break;
                case ButtonImages.chnEnable:
                    bt = new Bitmap(Resource1.chnEnable);
                    break;
                case ButtonImages.chnEnterDown:
                    bt = new Bitmap(Resource1.chnEnterDown);
                    break;
                case ButtonImages.chnEnterUp:
                    bt = new Bitmap(Resource1.chnEnterUp);
                    break;
                case ButtonImages.chnFormCalibrationCancelDisable:
                    bt = new Bitmap(Resource1.chnFormCalibrationCancelDisable);
                    break;
                case ButtonImages.chnFormCalibrationCancelDown:
                    bt = new Bitmap(Resource1.chnFormCalibrationCancelDown);
                    break;
                case ButtonImages.chnFormCalibrationCancelUp:
                    bt = new Bitmap(Resource1.chnFormCalibrationCancelUp);
                    break;
                case ButtonImages.chnFormCalibrationStartDisable:
                    bt = new Bitmap(Resource1.chnFormCalibrationStartDisable);
                    break;
                case ButtonImages.chnFormCalibrationStartDown:
                    bt = new Bitmap(Resource1.chnFormCalibrationStartDown);
                    break;
                case ButtonImages.chnFormCalibrationStartUp:
                    bt = new Bitmap(Resource1.chnFormCalibrationStartUp);
                    break;
                case ButtonImages.chnFormCalibrationWeightDisable:
                    bt = new Bitmap(Resource1.chnFormCalibrationWeightDisable);
                    break;
                case ButtonImages.chnFormCalibrationWeightDown:
                    bt = new Bitmap(Resource1.chnFormCalibrationWeightDown);
                    break;
                case ButtonImages.chnFormCalibrationWeightUp:
                    bt = new Bitmap(Resource1.chnFormCalibrationWeightUp);
                    break;
                case ButtonImages.chnFormMainDisplayLoginDisable:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLoginDisable);
                    break;
                case ButtonImages.chnFormMainDisplayLoginDown:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLoginDown);
                    break;
                case ButtonImages.chnFormMainDisplayLoginUp:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLoginUp);
                    break;
                case ButtonImages.chnFormMainDisplayLogoutDisable:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLogoutDisable);
                    break;
                case ButtonImages.chnFormMainDisplayLogoutDown:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLogoutDown);
                    break;
                case ButtonImages.chnFormMainDisplayLogoutUp:
                    bt = new Bitmap(Resource1.chnFormMainDisplayLogoutUp);
                    break;
                case ButtonImages.chnFormMainDisplayMenuBigDisable:
                    bt = new Bitmap(Resource1.korFormMainDisplayMenuBigDisable);
                    break;
                case ButtonImages.chnFormMainDisplayMenuBigDown:
                    bt = new Bitmap(Resource1.chnFormMainDisplayMenuBigDown);
                    break;
                case ButtonImages.chnFormMainDisplayMenuBigUp:
                    bt = new Bitmap(Resource1.chnFormMainDisplayMenuBigUp);
                    break;
                case ButtonImages.chnFormMainDisplayMenuDisable:
                    bt = new Bitmap(Resource1.chnFormMainDisplayMenuDisable);
                    break;
                case ButtonImages.chnFormMainDisplayMenuDown:
                    bt = new Bitmap(Resource1.chnFormMainDisplayMenuDown);
                    break;
                case ButtonImages.chnFormMainDisplayMenuUp:
                    bt = new Bitmap(Resource1.chnFormMainDisplayMenuUp);
                    break;
                case ButtonImages.chnFormMainOverDisable:
                    bt = new Bitmap(Resource1.chnFormMainOverDisable);
                    break;
                case ButtonImages.chnFormMainOverDown:
                    bt = new Bitmap(Resource1.chnFormMainOverDown);
                    break;
                case ButtonImages.chnFormMainOverUp:
                    bt = new Bitmap(Resource1.chnFormMainOverUp);
                    break;
                case ButtonImages.chnFormMainPassDisable:
                    bt = new Bitmap(Resource1.chnFormMainPassDisable);
                    break;
                case ButtonImages.chnFormMainPassDown:
                    bt = new Bitmap(Resource1.chnFormMainPassDown);
                    break;
                case ButtonImages.chnFormMainPassUp:
                    bt = new Bitmap(Resource1.chnFormMainPassUp);
                    break;
                case ButtonImages.chnFormMainTareDisable:
                    bt = new Bitmap(Resource1.chnFormMainTareDisable);
                    break;
                case ButtonImages.chnFormMainTareDown:
                    bt = new Bitmap(Resource1.chnFormMainTareDown);
                    break;
                case ButtonImages.chnFormMainTareUp:
                    bt = new Bitmap(Resource1.chnFormMainTareUp);
                    break;
                case ButtonImages.chnFormMainUnderDisable:
                    bt = new Bitmap(Resource1.chnFormMainUnderDisable);
                    break;
                case ButtonImages.chnFormMainUnderDown:
                    bt = new Bitmap(Resource1.chnFormMainUnderDown);
                    break;
                case ButtonImages.chnFormMainUnderUp:
                    bt = new Bitmap(Resource1.chnFormMainUnderUp);
                    break;
                #region 메뉴
                case ButtonImages.chnFormMenuCalibrationDisable:
                    bt = new Bitmap(Resource1.chnFormMenuCalibrationDisable);
                    break;
                case ButtonImages.chnFormMenuCalibrationDown:
                    bt = new Bitmap(Resource1.chnFormMenuCalibrationDown);
                    break;
                case ButtonImages.chnFormMenuCalibrationUp:
                    bt = new Bitmap(Resource1.chnFormMenuCalibrationUp);
                    break;
                case ButtonImages.chnFormMenuCommunicationDisable:
                    bt = new Bitmap(Resource1.chnFormMenuCommunicationDisable);
                    break;
                case ButtonImages.chnFormMenuCommunicationDown:
                    bt = new Bitmap(Resource1.chnFormMenuCommunicationDown);
                    break;
                case ButtonImages.chnFormMenuCommunicationUp:
                    bt = new Bitmap(Resource1.chnFormMenuCommunicationUp);
                    break;
                case ButtonImages.chnFormMenuConfigurationDisable:
                    bt = new Bitmap(Resource1.chnFormMenuConfigurationDisable);
                    break;
                case ButtonImages.chnFormMenuConfigurationDown:
                    bt = new Bitmap(Resource1.chnFormMenuConfigurationDown);
                    break;
                case ButtonImages.chnFormMenuConfigurationUp:
                    bt = new Bitmap(Resource1.chnFormMenuConfigurationUp);
                    break;
                case ButtonImages.chnFormMenuDataBackupDisable:
                    bt = new Bitmap(Resource1.chnFormMenuDataBackupDisable);
                    break;
                case ButtonImages.chnFormMenuDataBackupDown:
                    bt = new Bitmap(Resource1.chnFormMenuDataBackupDown);
                    break;
                case ButtonImages.chnFormMenuDataBackupUp:
                    bt = new Bitmap(Resource1.chnFormMenuDataBackupUp);
                    break;
                case ButtonImages.chnFormMenuDataViewerDisable:
                    bt = new Bitmap(Resource1.chnFormMenuDataViewerDisable);
                    break;
                case ButtonImages.chnFormMenuDataViewerDown:
                    bt = new Bitmap(Resource1.chnFormMenuDataViewerDown);
                    break;
                case ButtonImages.chnFormMenuDataViewerUp:
                    bt = new Bitmap(Resource1.chnFormMenuDataViewerUp);
                    break;
                case ButtonImages.chnFormMenuEquipmentDisable:
                    bt = new Bitmap(Resource1.chnFormMenuEquipmentDisable);
                    break;
                case ButtonImages.chnFormMenuEquipmentDown:
                    bt = new Bitmap(Resource1.chnFormMenuEquipmentDown);
                    break;
                case ButtonImages.chnFormMenuEquipmentUp:
                    bt = new Bitmap(Resource1.chnFormMenuEquipmentUp);
                    break;
                case ButtonImages.chnFormMenuInformationDisable:
                    bt = new Bitmap(Resource1.chnFormMenuInformationDisable);
                    break;
                case ButtonImages.chnFormMenuInformationDown:
                    bt = new Bitmap(Resource1.chnFormMenuInformationDown);
                    break;
                case ButtonImages.chnFormMenuInformationUp:
                    bt = new Bitmap(Resource1.chnFormMenuInformationUp);
                    break;
                case ButtonImages.chnFormMenuInitializationDisable:
                    bt = new Bitmap(Resource1.chnFormMenuInitializationDisable);
                    break;
                case ButtonImages.chnFormMenuInitializationDown:
                    bt = new Bitmap(Resource1.chnFormMenuInitializationDown);
                    break;
                case ButtonImages.chnFormMenuInitializationUp:
                    bt = new Bitmap(Resource1.chnFormMenuInitializationUp);
                    break;
                case ButtonImages.chnFormMenuIOTestDisable:
                    bt = new Bitmap(Resource1.chnFormMenuIOTestDisable);
                    break;
                case ButtonImages.chnFormMenuIOTestDown:
                    bt = new Bitmap(Resource1.chnFormMenuIOTestDown);
                    break;
                case ButtonImages.chnFormMenuIOTestUp:
                    bt = new Bitmap(Resource1.chnFormMenuIOTestUp);
                    break;
                case ButtonImages.chnFormMenuMotorDisable:
                    bt = new Bitmap(Resource1.chnFormMenuMotorDisable);
                    break;
                case ButtonImages.chnFormMenuMotorDown:
                    bt = new Bitmap(Resource1.chnFormMenuMotorDown);
                    break;
                case ButtonImages.chnFormMenuMotorUp:
                    bt = new Bitmap(Resource1.chnFormMenuMotorUp);
                    break;
                case ButtonImages.chnFormMenuStatisticsDisable:
                    bt = new Bitmap(Resource1.chnFormMenuStatisticsDisable);
                    break;
                case ButtonImages.chnFormMenuStatisticsDown:
                    bt = new Bitmap(Resource1.chnFormMenuStatisticsDown);
                    break;
                case ButtonImages.chnFormMenuStatisticsUp:
                    bt = new Bitmap(Resource1.chnFormMenuStatisticsUp);
                    break;
                case ButtonImages.chnFormMenuSystemDisable:
                    bt = new Bitmap(Resource1.chnFormMenuSystemDisable);
                    break;
                case ButtonImages.chnFormMenuSystemDown:
                    bt = new Bitmap(Resource1.chnFormMenuSystemDown);
                    break;
                case ButtonImages.chnFormMenuSystemUp:
                    bt = new Bitmap(Resource1.chnFormMenuSystemUp);
                    break;
                case ButtonImages.chnFormMenuTestDisable:
                    bt = new Bitmap(Resource1.chnFormMenuTestDisable);
                    break;
                case ButtonImages.chnFormMenuTestDown:
                    bt = new Bitmap(Resource1.chnFormMenuTestDown);
                    break;
                case ButtonImages.chnFormMenuTestUp:
                    bt = new Bitmap(Resource1.chnFormMenuTestUp);
                    break;
                case ButtonImages.chnFormMenuTimeDisable:
                    bt = new Bitmap(Resource1.chnFormMenuTimeDisable);
                    break;
                case ButtonImages.chnFormMenuTimeDown:
                    bt = new Bitmap(Resource1.chnFormMenuTimeDown);
                    break;
                case ButtonImages.chnFormMenuTimeUp:
                    bt = new Bitmap(Resource1.chnFormMenuTimeUp);
                    break;
                case ButtonImages.chnFormMenuUpdateDisable:
                    bt = new Bitmap(Resource1.chnFormMenuUpdateDisable);
                    break;
                case ButtonImages.chnFormMenuUpdateDown:
                    bt = new Bitmap(Resource1.chnFormMenuUpdateDown);
                    break;
                case ButtonImages.chnFormMenuUpdateUp:
                    bt = new Bitmap(Resource1.chnFormMenuUpdateUp);
                    break;
                case ButtonImages.chnFormMenuUserDisable:
                    bt = new Bitmap(Resource1.chnFormMenuUserDisable);
                    break;
                case ButtonImages.chnFormMenuUserDown:
                    bt = new Bitmap(Resource1.chnFormMenuUserDown);
                    break;
                case ButtonImages.chnFormMenuUserUp:
                    bt = new Bitmap(Resource1.chnFormMenuUserUp);
                    break;
                #endregion
                case ButtonImages.chnFormSystemSettingNoDown:
                    bt = new Bitmap(Resource1.chnFormSystemSettingNoDown);
                    break;
                case ButtonImages.chnFormSystemSettingNoUp:
                    bt = new Bitmap(Resource1.chnFormSystemSettingNoUp);
                    break;
                case ButtonImages.chnFormSystemSettingOverDown:
                    bt = new Bitmap(Resource1.chnFormSystemSettingOverDown);
                    break;
                case ButtonImages.chnFormSystemSettingOverUp:
                    bt = new Bitmap(Resource1.chnFormSystemSettingOverUp);
                    break;
                case ButtonImages.chnFormSystemSettingPassDown:
                    bt = new Bitmap(Resource1.chnFormSystemSettingPassDown);
                    break;
                case ButtonImages.chnFormSystemSettingPassUp:
                    bt = new Bitmap(Resource1.chnFormSystemSettingPassUp);
                    break;
                case ButtonImages.chnFormSystemSettingTareDown:
                    bt = new Bitmap(Resource1.chnFormSystemSettingTareDown);
                    break;
                case ButtonImages.chnFormSystemSettingTareUp:
                    bt = new Bitmap(Resource1.chnFormSystemSettingTareUp);
                    break;
                case ButtonImages.chnFormSystemSettingUnderDown:
                    bt = new Bitmap(Resource1.chnFormSystemSettingUnderDown);
                    break;
                case ButtonImages.chnFormSystemSettingUnderUp:
                    bt = new Bitmap(Resource1.chnFormSystemSettingUnderUp);
                    break;
                case ButtonImages.chnPasteAllDown:
                    bt = new Bitmap(Resource1.chnPasteAllDown);
                    break;
                case ButtonImages.chnPasteAllUp:
                    bt = new Bitmap(Resource1.chnPasteAllUp);
                    break;
                case ButtonImages.chnPasteDown:
                    bt = new Bitmap(Resource1.chnPasteDown);
                    break;
                case ButtonImages.chnPasteUp:
                    bt = new Bitmap(Resource1.chnPasteUp);
                    break;
                case ButtonImages.chnMainCancelDisable:
                    bt = new Bitmap(Resource1.chnMainCancelDisable);
                    break;
                case ButtonImages.chnMainCancelDown:
                    bt = new Bitmap(Resource1.chnMainCancelDown);
                    break;
                case ButtonImages.chnMainCancelUp:
                    bt = new Bitmap(Resource1.chnMainCancelUp);
                    break;
                case ButtonImages.chnMainLoginDisable:
                    bt = new Bitmap(Resource1.chnMainLoginDisable);
                    break;
                case ButtonImages.chnMainLoginDown:
                    bt = new Bitmap(Resource1.chnMainLoginDown);
                    break;
                case ButtonImages.chnMainLoginUp:
                    bt = new Bitmap(Resource1.chnMainLoginUp);
                    break;
                #endregion
                #region 한글
                case ButtonImages.korBackgroundUserLogin:
                    bt = new Bitmap(Resource1.korBackgroundUserLogin);
                    break;
                case ButtonImages.korFormMainDisplayMenuBigDisable:
                    bt = new Bitmap(Resource1.korFormMainDisplayMenuBigDisable);
                    break;
                case ButtonImages.korFormMainDisplayMenuBigDown:
                    bt = new Bitmap(Resource1.korFormMainDisplayMenuBigDown);
                    break;
                case ButtonImages.korFormMainDisplayMenuBigUp:
                    bt = new Bitmap(Resource1.korFormMainDisplayMenuBigUp);
                    break;
                #region 메뉴
                case ButtonImages.korFormMenuCalibrationDisable:
                    bt = new Bitmap(Resource1.korFormMenuCalibrationDisable);
                    break;
                case ButtonImages.korFormMenuCalibrationDown:
                    bt = new Bitmap(Resource1.korFormMenuCalibrationDown);
                    break;
                case ButtonImages.korFormMenuCalibrationUp:
                    bt = new Bitmap(Resource1.korFormMenuCalibrationUp);
                    break;
                case ButtonImages.korFormMenuCommunicationDisable:
                    bt = new Bitmap(Resource1.korFormMenuCommunicationDisable);
                    break;
                case ButtonImages.korFormMenuCommunicationDown:
                    bt = new Bitmap(Resource1.korFormMenuCommunicationDown);
                    break;
                case ButtonImages.korFormMenuCommunicationUp:
                    bt = new Bitmap(Resource1.korFormMenuCommunicationUp);
                    break;
                case ButtonImages.korFormMenuConfigurationDisable:
                    bt = new Bitmap(Resource1.korFormMenuConfigurationDisable);
                    break;
                case ButtonImages.korFormMenuConfigurationDown:
                    bt = new Bitmap(Resource1.korFormMenuConfigurationDown);
                    break;
                case ButtonImages.korFormMenuConfigurationUp:
                    bt = new Bitmap(Resource1.korFormMenuConfigurationUp);
                    break;
                case ButtonImages.korFormMenuDataBackupDisable:
                    bt = new Bitmap(Resource1.korFormMenuDataBackupDisable);
                    break;
                case ButtonImages.korFormMenuDataBackupDown:
                    bt = new Bitmap(Resource1.korFormMenuDataBackupDown);
                    break;
                case ButtonImages.korFormMenuDataBackupUp:
                    bt = new Bitmap(Resource1.korFormMenuDataBackupUp);
                    break;
                case ButtonImages.korFormMenuDataViewerDisable:
                    bt = new Bitmap(Resource1.korFormMenuDataViewerDisable);
                    break;
                case ButtonImages.korFormMenuDataViewerDown:
                    bt = new Bitmap(Resource1.korFormMenuDataViewerDown);
                    break;
                case ButtonImages.korFormMenuDataViewerUp:
                    bt = new Bitmap(Resource1.korFormMenuDataViewerUp);
                    break;
                case ButtonImages.korFormMenuEquipmentDisable:
                    bt = new Bitmap(Resource1.korFormMenuEquipmentDisable);
                    break;
                case ButtonImages.korFormMenuEquipmentDown:
                    bt = new Bitmap(Resource1.korFormMenuEquipmentDown);
                    break;
                case ButtonImages.korFormMenuEquipmentUp:
                    bt = new Bitmap(Resource1.korFormMenuEquipmentUp);
                    break;
                case ButtonImages.korFormMenuInformationDisable:
                    bt = new Bitmap(Resource1.korFormMenuInformationDisable);
                    break;
                case ButtonImages.korFormMenuInformationDown:
                    bt = new Bitmap(Resource1.korFormMenuInformationDown);
                    break;
                case ButtonImages.korFormMenuInformationUp:
                    bt = new Bitmap(Resource1.korFormMenuInformationUp);
                    break;
                case ButtonImages.korFormMenuInitializationDisable:
                    bt = new Bitmap(Resource1.korFormMenuInitializationDisable);
                    break;
                case ButtonImages.korFormMenuInitializationDown:
                    bt = new Bitmap(Resource1.korFormMenuInitializationDown);
                    break;
                case ButtonImages.korFormMenuInitializationUp:
                    bt = new Bitmap(Resource1.korFormMenuInitializationUp);
                    break;
                case ButtonImages.korFormMenuIOTestDisable:
                    bt = new Bitmap(Resource1.korFormMenuIOTestDisable);
                    break;
                case ButtonImages.korFormMenuIOTestDown:
                    bt = new Bitmap(Resource1.korFormMenuIOTestDown);
                    break;
                case ButtonImages.korFormMenuIOTestUp:
                    bt = new Bitmap(Resource1.korFormMenuIOTestUp);
                    break;
                case ButtonImages.korFormMenuMotorDisable:
                    bt = new Bitmap(Resource1.korFormMenuMotorDisable);
                    break;
                case ButtonImages.korFormMenuMotorDown:
                    bt = new Bitmap(Resource1.korFormMenuMotorDown);
                    break;
                case ButtonImages.korFormMenuMotorUp:
                    bt = new Bitmap(Resource1.korFormMenuMotorUp);
                    break;
                case ButtonImages.korFormMenuStatisticsDisable:
                    bt = new Bitmap(Resource1.korFormMenuStatisticsDisable);
                    break;
                case ButtonImages.korFormMenuStatisticsDown:
                    bt = new Bitmap(Resource1.korFormMenuStatisticsDown);
                    break;
                case ButtonImages.korFormMenuStatisticsUp:
                    bt = new Bitmap(Resource1.korFormMenuStatisticsUp);
                    break;
                case ButtonImages.korFormMenuSystemDisable:
                    bt = new Bitmap(Resource1.korFormMenuSystemDisable);
                    break;
                case ButtonImages.korFormMenuSystemDown:
                    bt = new Bitmap(Resource1.korFormMenuSystemDown);
                    break;
                case ButtonImages.korFormMenuSystemUp:
                    bt = new Bitmap(Resource1.korFormMenuSystemUp);
                    break;
                case ButtonImages.korFormMenuTestDisable:
                    bt = new Bitmap(Resource1.korFormMenuTestDisable);
                    break;
                case ButtonImages.korFormMenuTestDown:
                    bt = new Bitmap(Resource1.korFormMenuTestDown);
                    break;
                case ButtonImages.korFormMenuTestUp:
                    bt = new Bitmap(Resource1.korFormMenuTestUp);
                    break;
                case ButtonImages.korFormMenuTimeDisable:
                    bt = new Bitmap(Resource1.korFormMenuTimeDisable);
                    break;
                case ButtonImages.korFormMenuTimeDown:
                    bt = new Bitmap(Resource1.korFormMenuTimeDown);
                    break;
                case ButtonImages.korFormMenuTimeUp:
                    bt = new Bitmap(Resource1.korFormMenuTimeUp);
                    break;
                case ButtonImages.korFormMenuUpdateDisable:
                    bt = new Bitmap(Resource1.korFormMenuUpdateDisable);
                    break;
                case ButtonImages.korFormMenuUpdateDown:
                    bt = new Bitmap(Resource1.korFormMenuUpdateDown);
                    break;
                case ButtonImages.korFormMenuUpdateUp:
                    bt = new Bitmap(Resource1.korFormMenuUpdateUp);
                    break;
                case ButtonImages.korFormMenuUserDisable:
                    bt = new Bitmap(Resource1.korFormMenuUserDisable);
                    break;
                case ButtonImages.korFormMenuUserDown:
                    bt = new Bitmap(Resource1.korFormMenuUserDown);
                    break;
                case ButtonImages.korFormMenuUserUp:
                    bt = new Bitmap(Resource1.korFormMenuUserUp);
                    break;
                #endregion
                #endregion
                default :
                    bt = new Bitmap(Resource1.korFormMenuUserUp);
                    break;
            }

            return bt;
        }
    }
}
